#include "StdAfx.h"
#include "Camera.h"

CCamera::CCamera()
{
	D3DXVECTOR3 eye(0.0f, 0.0f, -200.0f);
	D3DXVECTOR3 look(0.0f, 0.0f, 0.0f);
	D3DXVECTOR3 up(0.0f, 1.0f, 0.0f);
	SetViewParams(eye, look, up);

	//  ʱ 
//	SetProjParams(D3DX_PI/4, 4.0f/3.0f, 1.0f, 1000.0f);

	// ȸ   ʱȭ
	m_fAngleVertical	=  45.0f;	//  +45(x)
	m_fAngleHorizon		= -90.0f;	// ¿ -90(y)
	m_fMaxDistance		= 3000.0f;
}

//-----------------------------------------------------------------------------
// Name:
// Desc: Construction
//-----------------------------------------------------------------------------
CCamera::CCamera(D3DXVECTOR3& eye, D3DXVECTOR3& look, D3DXVECTOR3& up, int width, int height)
{
    // ī޶ ʱ 
	SetViewParams(eye, look, up);

    //  ʱ 
//	SetProjParams(D3DX_PI/4, 4.0f/3.0f, 1.0f, 1000.0f);

	// ȸ   ʱȭ
	m_fAngleVertical	=  45.0f;	//  +45(x)
	m_fAngleHorizon		= -90.0f;	// ¿ -90(y)
	m_fMaxDistance		= 3000.0f;
}

//-----------------------------------------------------------------------------
// Name:
// Desc: Destruction
//-----------------------------------------------------------------------------
CCamera::~CCamera()
{
}

//-----------------------------------------------------------------------------
// Name: SetViewParams()
// Desc: ī޶ view  
//-----------------------------------------------------------------------------
VOID CCamera::SetViewParams(D3DXVECTOR3& vEyePt, D3DXVECTOR3& vLookatPt, D3DXVECTOR3& vUpVec)
{
    m_vEyePt    = vEyePt;
    m_vLookatPt = vLookatPt;
    m_vUpVec    = vUpVec;
    
	// Ķ 
	SetupParams();
}

//-----------------------------------------------------------------------------
// Name: SetProjParams()
// Desc: Էµ   ȯ
//-----------------------------------------------------------------------------
VOID CCamera::SetProjParams(float fFOV, float fAspect, float fNearPlane, float fFarPlane)
{
    //  ȯ   Է
    m_fFOV        = fFOV;
    m_fAspect     = fAspect;
    m_fNearPlane  = fNearPlane;
    m_fFarPlane   = fFarPlane;

    D3DXMatrixPerspectiveFovLH(&m_matProj, fFOV, fAspect, fNearPlane, fFarPlane);
}

//-----------------------------------------------------------------------------
// Name: SetupParams()
// Desc: ī޶ ġ (°,,)  ī޶ ġ 
//-----------------------------------------------------------------------------
VOID CCamera::SetupParams()
{	
	//-----------------------------------------------------------------------------
	//	vLookatPt  vEyePt Ѵ.
	//-----------------------------------------------------------------------------
	D3DXVECTOR3 vec = m_vEyePt;	// vEyePt ī޶ ġ
			
	/******************************************************************************
	//˰
	dx = cos(vertical)cos(horizon)
	dy = sin(vertical)
	dz = cos(vertical)sin(horizon)
	*******************************************************************************/
	vec -= m_vLookatPt;
	float length = D3DXVec3Length(&vec);
	
	vec.x = length * cosf(D3DXToRadian(m_fAngleVertical)) * cosf(D3DXToRadian(m_fAngleHorizon));
	vec.y = length * sinf(D3DXToRadian(m_fAngleVertical));
	vec.z = length * cosf(D3DXToRadian(m_fAngleVertical)) * sinf(D3DXToRadian(m_fAngleHorizon));
	
	vec	+= m_vLookatPt;	// vLookatPt ؼ vLookatPt ġŭ ̵Ų.
	m_vEyePt = vec;


	//-----------------------------------------------------------------------------	
	//	vView(ٶ󺸴), vUpVec(), vCross() ͸ Ѵ.
	//-----------------------------------------------------------------------------
	vec = m_vLookatPt - m_vEyePt;
	vec.y = 0.0f;

	D3DXVec3Normalize(&m_vView, &vec);				// ٶ󺸴°  
	D3DXVec3Cross(&m_vCross, &m_vUpVec, &m_vView);	//   (vView vUpVec )
	
	// ī޶  Ѵ.
	D3DXMatrixLookAtLH(&m_matView, &m_vEyePt, &m_vLookatPt, &m_vUpVec);

	//-----------------------------------------------------------------------------	
	//	带  .
	//-----------------------------------------------------------------------------
	D3DXMatrixInverse(&m_matBillboard, NULL, &m_matView);
	m_matBillboard._41 = 0.0f;
	m_matBillboard._42 = 0.0f;
	m_matBillboard._43 = 0.0f;
}

//-----------------------------------------------------------------------------
// Name: MoveCamera()
// Desc: ī޶ յ, ¿ ̵
//-----------------------------------------------------------------------------
VOID CCamera::MoveCamera(float forward, float cross)
{
	m_vEyePt	+= (m_vView * forward);
	m_vLookatPt += (m_vView * forward);
	m_vEyePt	-= (m_vCross * cross);
	m_vLookatPt -= (m_vCross * cross);

	//Ķ̷ 
	SetupParams();
}

//-----------------------------------------------------------------------------
// Name: RotateCamera()
// Desc:  lookat ߽ ¿ Ʒ ȸ Ѵ.
//-----------------------------------------------------------------------------
VOID CCamera::RotateCamera(float horizon, float vertical)
{
	// 簢 ߰ Ѵ.(Ѵ.)
	m_fAngleHorizon	 += horizon;
	m_fAngleVertical += vertical;

	//-----------------------------------------------------------------------------	
	//	Ѱġ .
	//-----------------------------------------------------------------------------
	// ¿ 360 ~ -360 .
	if(m_fAngleHorizon > 360.0f)
		m_fAngleHorizon -= 360.0f;
	else if(m_fAngleHorizon < 0.0f)
		m_fAngleHorizon += 360.0f;

	// δ 85 ̻ ö󰡰 .
	if(m_fAngleVertical > 80.0f)
	{ m_fAngleVertical = 80.0f; }

	// Ʒδ 5   .
	if(m_fAngleVertical < 8.0f)
	{ m_fAngleVertical = 8.0f; }

	//Ķ̷ 
	SetupParams();
}

//-----------------------------------------------------------------------------
// Name: ZoomCamera()
// Desc:  ī޶ ָϰų  Ѵ.
//-----------------------------------------------------------------------------
VOID CCamera::ZoomCamera(float zoom)
{
	D3DXVECTOR3 vec = m_vLookatPt - m_vEyePt;	// ī޶ ͸ Ѵ.

	//͸   (zoom) ũ⸦ Ѵ.
	D3DXVec3Normalize(&vec, &vec);
	vec *= zoom;

	//  ġ   Ÿ ؼ Ѱ Ѵ.
	float length = D3DXVec3Length(&(m_vEyePt - m_vLookatPt + vec));
	if(50.0f <= length && length <= m_fMaxDistance)
	{
		m_vEyePt += vec;
	}

	//Ķ 
	SetupParams();
}