#pragma once

#include <d3d9.h>
#include <d3dx9.h>

class CCamera
{
private:
	D3DXVECTOR3 m_vEyePt;		//  ī޶ ġ
	D3DXVECTOR3 m_vLookatPt;	// ī޶ ٶ󺸴°
	D3DXVECTOR3 m_vUpVec;		//  ī޶ ġ up 

	D3DXVECTOR3 m_vView;		//  ī޶ ġ look 
	D3DXVECTOR3 m_vCross;		//  ī޶ ġ right 
	
	D3DXMATRIX  m_matView;		//  
	D3DXMATRIX  m_matBillboard; //  

	float       m_fNearPlane;	//  Ŭ 
	float       m_fFarPlane;	//  Ŭ 
	D3DXMATRIX  m_matProj;		//  

	//ȸ 
	float m_fAngleHorizon;		// ()
	float m_fAngleVertical;		// ()

public:
	float       m_fFOV;				// þ߰
	float       m_fAspect;			// Ⱦ(/)
	float		m_fMaxDistance;		// ī޶ ְŸ
	float		m_fFrustumDistance;	// Frustum ְŸ

public:
	CCamera();
	CCamera(D3DXVECTOR3& eye, D3DXVECTOR3& look, D3DXVECTOR3& up, int width, int height);
	~CCamera();

	// ٰ Լ(Get Fuction)
	D3DXVECTOR3 GetEyePt()          { return m_vEyePt; }
	D3DXVECTOR3 GetLookatPt()       { return m_vLookatPt; }
	D3DXVECTOR3 GetUpVec()          { return m_vUpVec; }
	D3DXVECTOR3 GetViewDir()        { return m_vView; }
	D3DXVECTOR3 GetCross()          { return m_vCross; }
	float		GetDistance()		{ return D3DXVec3Length(&(m_vLookatPt - m_vEyePt)); }

	D3DXMATRIX  GetViewMatrix()     { return m_matView; }
	D3DXMATRIX  GetBillboardMatrix(){ return m_matBillboard; }
	D3DXMATRIX  GetProjMatrix()     { return m_matProj; }

	//  Լ(Set Fuction)
	void SetViewParams(D3DXVECTOR3 &vEyePt, D3DXVECTOR3& vLookatPt, D3DXVECTOR3& vUpVec);
	void SetProjParams(float fFOV, float fAspect, float fNearPlane, float fFarPlane);

public:
	// ߰Լ(Add Function)
	// ī޶ ̵, ȸ, ,  Լ...
	void MoveCamera(float forward, float cross);
	void RotateCamera(float horizon, float vertical);
	void ZoomCamera(float zoom);
	void SetupParams();
};