#pragma once

#include "Terrain.h"

class CDecodeSOF
{
private:
	CTerrain*	m_pTerrain;

private:
    void	SaveFileInfo(FILE* fp, wchar_t* pFileInfo);
	void	SaveMapInfo(FILE* fp);
	void	SaveTileInfo(FILE* fp);
	void	SaveTexture(FILE* fp);
	void	SaveAlphaTexture(FILE* fp, const wchar_t* pFileName);

	void	LoadFileInfo(FILE* fp, wchar_t* pFileInfo);
	void	LoadMapInfo(FILE* fp);
	void	LoadTileInfo(FILE* fp);
	void	LoadTexture(FILE* fp);
	void	LoadAlphaTexture(FILE* fp, const wchar_t* pFileName);

public:
	CDecodeSOF();
	~CDecodeSOF();

	bool	SaveSOF(const wchar_t* pFileName, CTerrain* pTerrain);
	bool	LodeSOF(const wchar_t* pFileName, CTerrain* pTerrain);
};