#pragma once

#include <d3d9.h>
#include <d3dx9.h>
#include <windows.h>

#define COLOR_BG		D3DCOLOR_XRGB(0,0,0)
#define COLOR_FONT		D3DCOLOR_XRGB(255,0,255)
#define COLOR_BOUNDARY	D3DCOLOR_XRGB(255,0,255)

struct PREVIEWVERTEX
{
	D3DXVECTOR4	p;
	D3DXVECTOR2 t;

	enum { FVF = D3DFVF_XYZRHW | D3DFVF_TEX1 }; 
};

class CDirect3D_Base
{
private:
	void SetUpMatrix(int width, int height);
	void SetUpLight();

	void InitPreviewVertex(int width, int height);
	void DrawPreviewTexture();

public:
	CDirect3D_Base();
	~CDirect3D_Base();

	LPDIRECT3DDEVICE9	GetDevice(){ return m_pDevice; }
//	void SetUpFog(float, float, float denstity = 0.0f);

	HRESULT Init(HWND hWnd, int width, int height);

	// New device draw at a Map create
	HRESULT InitPreview(HWND hWnd, int width, int height);
	HRESULT LoadPreviewTexture(wchar_t *texName);
	void ReleasePreview();
	void RenderPreview();

private:
	LPDIRECT3D9			m_pD3D;
	LPDIRECT3DDEVICE9	m_pDevice;
	LPDIRECT3DTEXTURE9	m_pTex;
	PREVIEWVERTEX		m_pPreview[4];

public:
	LPDIRECT3DDEVICE9	m_pDevice_Preview;

};