#include "StdAfx.h"
#include "Font.h"

CD3DFont::CD3DFont()
{
	pD3dFont = NULL;
}

CD3DFont::~CD3DFont()
{
	if(pD3dFont != NULL)
	{ pD3dFont->Release(); }
}

HRESULT CD3DFont::SetFont(LPDIRECT3DDEVICE9 d3dDevice, LONG Width, LONG Height, wchar_t *FontName)
{
	D3DXFONT_DESC desc;
	ZeroMemory(&desc, sizeof(D3DXFONT_DESC));

	desc.Height = Height;
	desc.Width = Width;
	desc.Weight = FW_NORMAL;
	desc.MipLevels = 1;
	desc.Italic = 0;
	desc.CharSet = ANSI_CHARSET;
//	desc.CharSet = DEFAULT_CHARSET;
	desc.OutputPrecision = OUT_DEFAULT_PRECIS;
	desc.Quality = DEFAULT_QUALITY;
	desc.PitchAndFamily = FF_DONTCARE;
	wcscpy(desc.FaceName, FontName);
	
	if(FAILED(D3DXCreateFontIndirect(d3dDevice, &desc, &pD3dFont)))
	{ return E_FAIL; }

	return S_OK;
}

void CD3DFont::DrawText(LONG x, LONG y, LONG Width, LONG Height, D3DCOLOR color, UINT DIRECTION, wchar_t *String)
{
	RECT rc;
	rc.left = x;
	rc.top = y;
	rc.right = Width;
	rc.bottom = Height;

	pD3dFont->DrawText(NULL, String, -1, &rc, DIRECTION, color);
}

void CD3DFont::DrawText(LONG x, LONG y, LONG Width, LONG Height, D3DCOLOR color, UINT DIRECTION, long Numeric)
{
	wchar_t string[128];

	wsprintf(&string[0], L"%d", Numeric);
	DrawText(x, y, Width, Height, color, DIRECTION, &string[0]);
}

void CD3DFont::DrawTextEx(LONG x, LONG y, LONG Width, LONG Height, D3DCOLOR color, UINT DIRECTION , wchar_t *Format, ...)
{
	wchar_t string[128] = {0, };
	va_list ArgPtr;

	va_start(ArgPtr, Format);
	vswprintf(&string[0], Format, ArgPtr);
	va_end(ArgPtr);

	DrawText(x, y, Width, Height, color, DIRECTION, &string[0]);
}