#include "StdAfx.h"
#include "Frustum.h"

CFrustum::CFrustum(LPDIRECT3DDEVICE9 device)
{
	m_pDevice = device;
}

CFrustum::~CFrustum()
{
}

void CFrustum::FrustumInit()
{
	//  ȯ ǥ x, y -1.0 ~ 1.0f z 0 ~ 1 ȯȴ.
	m_vtx[0] = D3DXVECTOR3(-1.0f, -1.0f, 0.0f);
	m_vtx[1] = D3DXVECTOR3(1.0f, -1.0f, 0.0f);
	m_vtx[2] = D3DXVECTOR3(1.0f, -1.0f, 1.0f);
	m_vtx[3] = D3DXVECTOR3(-1.0f, -1.0f, 1.0f);	
	m_vtx[4] = D3DXVECTOR3(-1.0f,  1.0f, 0.0f);
	m_vtx[5] = D3DXVECTOR3(1.0f,  1.0f, 0.0f);
	m_vtx[6] = D3DXVECTOR3(1.0f,  1.0f, 1.0f);
	m_vtx[7] = D3DXVECTOR3(-1.0f,  1.0f, 1.0f);

	D3DXMATRIX matView, matProj, matViewProj;
	m_pDevice->GetTransform(D3DTS_VIEW, &matView);
	m_pDevice->GetTransform(D3DTS_PROJECTION, &matProj);
	D3DXMatrixMultiply(&matViewProj, &matView, &matProj);
	D3DXMatrixInverse(&matViewProj, NULL, &matViewProj);

	//   *   ϸ ǥ  ǥ   ִ.
	for(int i=0; i<8; i++)
	{
		D3DXVec3TransformCoord(&m_vtx[i], &m_vtx[i], &matViewProj);
	}
	
	// frustum Ѵ. 븻  ٱ
	D3DXPlaneFromPoints(&m_plane[0], &m_vtx[2], &m_vtx[6], &m_vtx[7]);//  (far)
	D3DXPlaneFromPoints(&m_plane[1], &m_vtx[0], &m_vtx[3], &m_vtx[7]);//  (left)
	D3DXPlaneFromPoints(&m_plane[2], &m_vtx[1], &m_vtx[5], &m_vtx[6]);//  (right)
	D3DXPlaneFromPoints(&m_plane[3], &m_vtx[4], &m_vtx[7], &m_vtx[6]);//  (top)
	D3DXPlaneFromPoints(&m_plane[4], &m_vtx[0], &m_vtx[1], &m_vtx[2]);//  (bottom)
	D3DXPlaneFromPoints(&m_plane[5], &m_vtx[0], &m_vtx[4], &m_vtx[5]);//  (near)
}

bool CFrustum::VertexIsInFrustum(D3DXVECTOR3* pv)
{
	int i=0;
	for(i=0 ; i<6; ++i)
	{
		float dist = D3DXPlaneDotCoord(&m_plane[i], pv);

		if(dist > 0.0f)
			return false;
	}

	return true;
}

bool CFrustum::SphereIsInFrustum(D3DXVECTOR3* pv, float radius)
{
	int i=0;
	for(i=0; i<6; ++i)
	{
		float dist = D3DXPlaneDotCoord(&m_plane[i], pv);

		if(dist > radius)
			return false;
	}

	return true;
}

///  ȭ鿡 ׷ش.
bool CFrustum::Draw()
{
	WORD index[] = {0, 1, 2,
					0, 2, 3,
					4, 7, 6,
					4, 6, 5,
					1, 5, 6,
					1, 6, 2,
					0, 3, 7,
					0, 7, 4,
					0, 4, 5,
					0, 5, 1,
					3, 7, 6,
					3, 6, 2};

    D3DMATERIAL9 mtrl;
    ZeroMemory(&mtrl, sizeof(D3DMATERIAL9));

	typedef struct tagVTX
	{
		D3DXVECTOR3	p;
	} VTX;

	VTX vtx[8];

	int i=0;
	for(i=0 ; i<8 ; ++i)
		vtx[i].p = m_vtx[i];

	m_pDevice->SetFVF(D3DFVF_XYZ);
	m_pDevice->SetStreamSource(0, NULL, 0, sizeof(VTX));
	m_pDevice->SetTexture(0, NULL);
	m_pDevice->SetIndices(0);
	m_pDevice->SetTextureStageState(0, D3DTSS_COLOROP,   D3DTOP_DISABLE);
	m_pDevice->SetTextureStageState(1, D3DTSS_COLOROP,   D3DTOP_DISABLE);
	m_pDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
	m_pDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_ONE);
	m_pDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ONE);

	// Ķ ,  ׸.
    m_pDevice->SetRenderState(D3DRS_LIGHTING, TRUE);
    ZeroMemory(&mtrl, sizeof(D3DMATERIAL9));
    mtrl.Diffuse.b = mtrl.Ambient.b = 1.0f;
    m_pDevice->SetMaterial(&mtrl);
	m_pDevice->DrawIndexedPrimitiveUP(D3DPT_TRIANGLELIST, 0, 8, 4, index, D3DFMT_INDEX16, vtx, sizeof(vtx[0]));

	//  ,  ׸.
    ZeroMemory(&mtrl, sizeof(D3DMATERIAL9));
    mtrl.Diffuse.g = mtrl.Ambient.g = 1.0f;
    m_pDevice->SetMaterial(&mtrl);
	m_pDevice->DrawIndexedPrimitiveUP(D3DPT_TRIANGLELIST, 0, 8, 4, index+4*3, D3DFMT_INDEX16, vtx, sizeof(vtx[0]));

	//  ,  ׸.
    ZeroMemory(&mtrl, sizeof(D3DMATERIAL9));
    mtrl.Diffuse.r = mtrl.Ambient.r = 1.0f;
    m_pDevice->SetMaterial(&mtrl);
	m_pDevice->DrawIndexedPrimitiveUP(D3DPT_TRIANGLELIST, 0, 8, 4, index+8*3, D3DFMT_INDEX16, vtx, sizeof(vtx[0]));

	m_pDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
    m_pDevice->SetRenderState(D3DRS_LIGHTING, FALSE);
	return TRUE;
}