#pragma once

#include <d3d9.h>
#include <dinput.h>

//-----------------------------------------------------------------------------
// MACROS
//-----------------------------------------------------------------------------
#define IS_USEKEYBOARD  1
#define IS_USEMOUSE     2

class CInput
{
private:
	LPDIRECTINPUT			m_lpDI;
    LPDIRECTINPUTDEVICE		m_lpKeyboard;
    LPDIRECTINPUTDEVICE		m_lpMouse;

    DIMOUSESTATE			m_MouseState;
    BYTE					m_KeyState[256];

public:
	CInput();
	~CInput();

	bool InitInput(HWND hWnd, HINSTANCE hInst);
	bool Update();

public:
	// Keyboard
	bool  KeyDown(BYTE key);
    bool  KeyUp(BYTE key);
    
	// Mouse
    bool  ButtonDown(int button);
    bool  ButtonUp(int button);
    void  GetMouseMovement(int &dx, int &dy);
    int   GetMouseWheelMovement();

	int	  GetMousePosX(){ return m_MouseState.lX; }
	int	  GetMousePosY(){ return m_MouseState.lY; }
};

extern CInput* g_pInput;