#pragma once

#include "Direct3D_Base.h"
#include "Camera.h"
#include "QuadTree.h"
#include "Font.h"
#include "Shader_Water.h"
#include "Shader_Fog.h"
#include "pSystem.h"

enum MODE { EDIT_HEIGHT=0, EDIT_TEXTURE, EDIT_OBJECT };

struct UserInput
{
	// 콺
    BOOL bLButtonDown;		// 콺 ʹư
	BOOL bRButtonDown;		// 콺  ư
	BOOL bLCtrlKeyDown;		// Ű Ʈ Ű
	BOOL bLAltKeyDown;		// Ű Ʈ Ű
	BOOL bLShiftKeyDown;	// Ű Ʈ Ű

	// delta
	FLOAT fMouseMoveDeltaX;	// x 
	FLOAT fMouseMoveDeltaY;	// y 
	FLOAT fMouseWheelDelta;	//  

	FLOAT fMouseSensitive;	// 콺 
	D3DXVECTOR3	vMousePos;	// 콺 ġ

	// ʱȭ  
	UserInput() { fMouseSensitive = 0.2f; };
};

struct AXISLINE
{
	D3DXVECTOR3 p;
	DWORD color;

	enum { FVF = D3DFVF_XYZ | D3DFVF_DIFFUSE };
};

class CMapTool_Mgr
{	
// Լ
private:
	void	UpdateInput(float timeDelta);
	void	UpdateCamera();

public:
	CMapTool_Mgr();
	~CMapTool_Mgr();

	HRESULT	Init(HWND hWnd, HINSTANCE hInst, int width, int height);
	void	CameraSetting();
	void	DeleteMap();
	void	CreateMap();
	void	InitTexturePreview();
	void	CountFPS();
	void	DrawAxisLine();
	void	FrameMove(float timeDelta);
	void	Render();

// 
private:
	LPDIRECT3DDEVICE9	m_pDevice;
	CQuadTree*			m_pQuadTree;
	CD3DFont*			m_pFont;

	// USER INPUT
	UserInput			m_UserInput;

	// FPS
	float				m_fps;
	int					m_nFrameCount;
	LARGE_INTEGER		m_frequency; // Ÿ̸ 󵵼 Ѵ.
	LARGE_INTEGER		m_startTime; //  īƮ 0϶ ð Ǵ 

public:
	CDirect3D_Base*		m_pDirect3D;
	CCamera*			m_pCamera;

	int					m_nWidth;
	int					m_nHeight;

	//  
	int					m_nEditMode;		// , ؽ, Ʈ

	// 귯
	BOOL				m_bIsPicking;		// ŷ Ұ üũ
	BOOL				m_bIsBrushInView;	// 콺 VIEWȿ ִ ˻

	// ī޶, 콺
	int					m_nCameraMove;		// ī޶  

	//  ɼ
	BOOL				m_bCoordinateAxis;	// ǥ

	CShader_Water		m_Shader_Water;
	Shader_Fog			m_Shader_Fog;
	psys::PSystem*		m_Particle_Snow;

	// ̸
	// ̸  CONTROLVIEW  ؽ ̾˷α׿ ´.
	HWND				m_hWnd_Preview;		// ؽ ̸ ڵ
	int					m_nWidth_Preview;	// ؽ ̸ ũ
	int					m_nHeight_Preview;	// ؽ ̸ ũ

};

extern CMapTool_Mgr g_ToolManager;