#pragma once

#include <d3d9.h>
#include <d3dx9.h>

#include "Terrain.h"

class CQuadTree
{
	enum	EDGE_TYPE	{ TL, TR, BL, BR };
	enum	INTERSECT	{ ALL_OUT=0, PART_IN, ALL_IN };

private:
	int				m_nCenter;
	int				m_nEdge[4];
	bool			m_bCulled;
	float			m_fRadius;
	CQuadTree*		m_pChild[4];

private:
	void		SetCorners(int _TL, int _TR, int _BL, int _BR);
	CQuadTree*	AddChild(int _TL, int _TR, int _BL, int _BR);
	bool		SetDivide();

	bool		IsVisible();
	int			IsInFrustum(CTerrain* pTerrain);
	void		FrustumCull(CTerrain* pTerrain);
	int			SearchDrawTile(int tileNum, CTerrain* pTerrain);

public:
	CQuadTree(int tileNum);
	CQuadTree(CQuadTree* pParent);
	~CQuadTree();

	void SetupQuadTree(CTerrain* pTerrain);
	void RevealDrawTiles(CTerrain* pTerrain);
};