#include "StdAfx.h"
#include "Direct3D_Base.h"
#include "Terrain.h"

CTerrain *g_pTerrain = NULL;

CTerrain::CTerrain(LPDIRECT3DDEVICE9 device)
{
	m_pDevice	= device;
	m_ppIB		= NULL;
	m_ppTexture	= NULL;

	int i=0;
	for(i=0; i<3; ++i)
		m_pAlphaTexture[i] = NULL;

	m_pFrustum = new CFrustum(device);
	m_bFrustumLock	= FALSE;

	::ZeroMemory(&m_MapInfo, sizeof(m_MapInfo));
	m_pTileInfo			= NULL;
	m_pHeightMap		= NULL;

	// LOD
	m_bApplyLOD			= FALSE;
	m_nMaxLODLevel		= 1;
	m_nLODLevelSize		= 1000;

	//  4 ؽ 밡(0 ⺻, 1~3÷  ؽ)
	for(i=0; i<4; ++i)
		m_nTextureIndex[i] = -1;

	m_nCurTexIndex		= -1;	//  ÷  ؽ ȣ
	m_nSelectTextureNum	= 1;	// õ ؽ 
	m_nTextureSplatting = -1;	// ÷ ϱ or 

	// STL vector(귯 ĥ   ϱ)
	m_vecSplattingTile.clear();

	// brush
	m_fBrushOutSize	= 0.0f;
	m_fBrushInSize	= 0.0f;
	m_nBrushType	= -1;	// , 簢
	
	// ɼ
	m_bWireFrame		= FALSE;
	m_bBoundaryLine		= FALSE;
//	m_bFog				= TRUE;
	m_bLight			= TRUE;
	m_nUpDownMode		= -1;	// ø, , , 
	m_nHeightRate		= 5;	//  

	// ü ؽ ̸ (string)
	m_strTextureName	= NULL;

	// STL vector(̴ Ÿ ã)
	m_vecVisibleTile.clear();

	// STL vector(귯  Ÿã)
	m_vecBrushAreaTile.clear();

	// pick
	m_vPickPos		= D3DXVECTOR3(0.0f, 0.0f, 0.0f);
	m_bPickOk		= FALSE;

}
/*
void CTerrain::GetCamera(CCamera *pCamera)
{
	m_pCamera = pCamera;
}
*/
CTerrain::~CTerrain()
{
	int i=0;
	int j=0;
	if(m_ppTexture)
	{
		for(i=0; i<m_MapInfo.nTextureNum; ++i)
			RELEASE(m_ppTexture[i]);

		DELS(m_ppTexture);
	}

	for(i=0; i<3; ++i)
		RELEASE(m_pAlphaTexture[i]);

	for(i=0; i<m_nMaxLODLevel; ++i)
	{
		for(j=0; j<5; ++j)
			RELEASE(m_ppIB[i][j]);
	}
	DELS(m_ppIB);

	DEL(m_pFrustum);
	DELS(m_pTileInfo);
	DELS(m_pHeightMap);
	DELS(m_strTextureName);
}

HRESULT CTerrain::InitTerrain(int tiles, int cells, int cellSpacing, int texNum, int baseTexIndex)
{
	int i=0;
	int j=0;
	
	// , Ÿ 
	SetupMapInfo(tiles, cells, cellSpacing, texNum);

	// ؽ ʱȭ
	m_nTextureIndex[0] = baseTexIndex;
	m_strTextureName = new wstring[m_MapInfo.nTextureNum];
	m_ppTexture = new LPDIRECT3DTEXTURE9[m_MapInfo.nTextureNum];
	for(i=0; i<m_MapInfo.nTextureNum; ++i)
		m_ppTexture[i] = NULL;

	//  
	SetupHeightMap();

	//  ŸϺ ٽ 
	m_pTileInfo = new TILEINFO[m_MapInfo.nTotalTiles];
	for(i=0; i<m_MapInfo.nTotalTiles; ++i)
	{
		if(FAILED(CreateVB(i, &m_pTileInfo[i])))
		{
			return E_FAIL;
		}
	}

	int devideCell = m_MapInfo.nCells;
	while(devideCell > 2)
	{
		devideCell /= 2;
        m_nMaxLODLevel++;
	}

	m_ppIB = new LPDIRECT3DINDEXBUFFER9[m_nMaxLODLevel][5];
	for(i=0; i<m_nMaxLODLevel; ++i)
	{
		// ε 
		if(FAILED(CreateIB(i)))
		{
			return E_FAIL;
		}
	}

	// ⺻ؽ   ؽĴ MainFrame LoadTexture .
	// ؽĵ ؽ ý 

	// 0 ~ 1 ؽ ͸ ʱȭ Ѵ.
	m_pDevice->SetSamplerState(0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR);
	m_pDevice->SetSamplerState(0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR);
	m_pDevice->SetSamplerState(0, D3DSAMP_MIPFILTER, D3DTEXF_LINEAR);
	m_pDevice->SetSamplerState(1, D3DSAMP_MINFILTER, D3DTEXF_LINEAR);
	m_pDevice->SetSamplerState(1, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR);
	m_pDevice->SetSamplerState(1, D3DSAMP_MIPFILTER, D3DTEXF_LINEAR);

	return S_OK;
}

void CTerrain::LoadTerrain()
{
	// ؽ  ( ʿ Ŭ̾Ʈ ÿ )
	int i=0;
	if(m_strTextureName == NULL)
		m_strTextureName = new wstring[m_MapInfo.nTextureNum];

	//  ü  ,
	// Ŭ̾Ʈ Ǵ ؽĸ ε
	if(m_ppTexture == NULL)
	{
		m_ppTexture = new LPDIRECT3DTEXTURE9[m_MapInfo.nTextureNum];
		for(i=0; i<m_MapInfo.nTextureNum; ++i)
			m_ppTexture[i] = NULL;
	}

	// ü  
	//  ̰ ˸  ڵ
	SetupHeightMap();

	int devideCell = m_MapInfo.nCells;
	while(devideCell > 2)
	{
		devideCell /= 2;
        m_nMaxLODLevel++;
	}

	m_ppIB = new LPDIRECT3DINDEXBUFFER9[m_nMaxLODLevel][5];
	for(i=0; i<m_nMaxLODLevel; ++i)
	{
		// ε 
		if(FAILED(CreateIB(i)))
		{
			MessageBox(NULL, L"CreateIB Error", L"ERROR", MB_OK);
			return;
		}
	}

	// 0 ~ 1 ؽ ͸ ʱȭ Ѵ.
	m_pDevice->SetSamplerState(0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR);
	m_pDevice->SetSamplerState(0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR);
	m_pDevice->SetSamplerState(0, D3DSAMP_MIPFILTER, D3DTEXF_LINEAR);
	m_pDevice->SetSamplerState(1, D3DSAMP_MINFILTER, D3DTEXF_LINEAR);
	m_pDevice->SetSamplerState(1, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR);
	m_pDevice->SetSamplerState(1, D3DSAMP_MIPFILTER, D3DTEXF_LINEAR);
}

void CTerrain::SetupMapInfo(int tiles, int cells, int cellSpacing, int texNum)
{
	m_MapInfo.nTiles			= tiles;						//  Ÿϰ(or)
	m_MapInfo.nTotalTiles		= tiles * tiles;				// ü Ÿϰ(*)
	m_MapInfo.nTotalVertices	= tiles * cells + 1;			//  ؽ (or)
	
	m_MapInfo.nCells			= cells;						// 1Ÿ ȿ ִ 
	m_MapInfo.nCellSpacing		= cellSpacing;					// 1Ÿ ȿ 1 ũ(Ÿ)
	m_MapInfo.nVertices			= (cells+1) * (cells+1);		// 1Ÿ ȿ ִ ؽ  
	m_MapInfo.nIndices			= cells * cells * 2 * 3;		// 1Ÿ ȿ ִ ε  
	m_MapInfo.nTriangles		= cells * cells * 2;			// 1Ÿ ȿ ִ ﰢ  
	m_MapInfo.nTextureNum		= texNum;						// ü ؽ 

	m_MapInfo.nTotalMapSize		= tiles * cells * cellSpacing;	//  or 
	m_MapInfo.nAlphaTexSize		= tiles * cells * 2;			// ؽó ũ(2 ϸ  )
}

void CTerrain::SetupHeightMap()
{
	//  ü  HeightMap 
	if(m_pHeightMap == NULL)
		m_pHeightMap = new TERRAINVERTEX[m_MapInfo.nTotalVertices * m_MapInfo.nTotalVertices];

	TERRAINVERTEX v;
	int i=0;
	int z=0;
	int x=0;
	for(z=0; z<m_MapInfo.nTotalVertices; ++z)
	{
		for(x=0; x<m_MapInfo.nTotalVertices; ++x)
		{
			v.p.x =  (float)(x * m_MapInfo.nCellSpacing); // x 0 ~ + 
			v.p.y =  0.0f;
			v.p.z = -(float)(z * m_MapInfo.nCellSpacing); // x 0 ~ - 

			v.n.x = 0.0f;
			v.n.y = 1.0f;
			v.n.z = 0.0f;
			D3DXVec3Normalize(&v.n, &v.n);

			// (tu,tv /  üؽ) = ׳ ü 0.0 ~ 1.0 ´.
			// ü uv ʿ, ŸϺ  ̱ 
			v.t1.x = 0.0f;
			v.t1.y = 0.0f;
			v.t2.x = 0.0f;
			v.t2.y = 0.0f;

			m_pHeightMap[i++] = v;
		}
	}
}

HRESULT CTerrain::CreateVB(int index, TILEINFO* pTileInfo)
{
	// ó ؽ Ѵ.
	if(pTileInfo->pVB == NULL && pTileInfo->pVertex == NULL)
	{
		pTileInfo->pVertex = new TERRAINVERTEX[m_MapInfo.nVertices];

		if(FAILED(m_pDevice->CreateVertexBuffer(m_MapInfo.nVertices * sizeof(TERRAINVERTEX),
			0, TERRAIN_FVF, D3DPOOL_DEFAULT, &pTileInfo->pVB, NULL)))
		{
			return S_OK;
		}
	}

	// x  = (ŸϹȣ % Ÿϰ) *  
	// z  = (ŸϹȣ / Ÿϰ) * ( üؽ * )
	int nextTileX = (index % m_MapInfo.nTiles) * m_MapInfo.nCells;
	int nextTileZ = (index / m_MapInfo.nTiles) * (m_MapInfo.nTotalVertices * m_MapInfo.nCells);

	// ؽó ǥ ϱ (ؽó 1  ŸϿ ȴ)
	float alphaTu = (float)(index % m_MapInfo.nTiles) / (float)m_MapInfo.nTiles;
	float alphaTv = (float)(index / m_MapInfo.nTiles) / (float)m_MapInfo.nTiles;

	int i=0;
	int z=0;
	int x=0;
	for(z=0; z<m_MapInfo.nCells+1; ++z)
	{
		for(x=0; x<m_MapInfo.nCells+1; ++x)
		{
			// ü ؽ ŸϺ Ѵ.
			pTileInfo->pVertex[i]		= m_pHeightMap[nextTileZ + nextTileX + (z * m_MapInfo.nTotalVertices) + x];
			pTileInfo->pVertex[i].t1.x	= (float)x / (float)(m_MapInfo.nCells); // ŸϺ 0.0 ~ 1.0 ´.
			pTileInfo->pVertex[i].t1.y	= (float)z / (float)(m_MapInfo.nCells); // ؽó Ʈ ̿ؼ .
			pTileInfo->pVertex[i].t2.x	= alphaTu + ((float)x / (float)(m_MapInfo.nTotalVertices-1));
			pTileInfo->pVertex[i].t2.y	= alphaTv + ((float)z / (float)(m_MapInfo.nTotalVertices-1));
			i++;
		}
	}
	// ŸϾȿ ִ ߿ 𼭸 4 ͸ Ѵ.
	// ŸϾȿ ε ƴ ü  ε ´.
	pTileInfo->nEdge[0]		= nextTileZ + nextTileX;
	pTileInfo->nEdge[1]		= nextTileZ + nextTileX + m_MapInfo.nCells;
	pTileInfo->nEdge[2]		= nextTileZ + nextTileX + (m_MapInfo.nCells * m_MapInfo.nTotalVertices);
	pTileInfo->nEdge[3]		= nextTileZ + nextTileX + (m_MapInfo.nCells * m_MapInfo.nTotalVertices) + m_MapInfo.nCells;

	pTileInfo->nCenter		= (pTileInfo->nEdge[0] + pTileInfo->nEdge[1] + pTileInfo->nEdge[2] + pTileInfo->nEdge[3]) / 4;

	pTileInfo->nLodLevel		= 0;
	pTileInfo->nLodCrackIndex	= 0;
	pTileInfo->nTriangleNum		= m_MapInfo.nCells * m_MapInfo.nCells * 2;

	TERRAINVERTEX* pV;
	if(FAILED(pTileInfo->pVB->Lock(0, m_MapInfo.nVertices * sizeof(TERRAINVERTEX), (void**)&pV, NULL)))
	{
		return E_FAIL;
	}
	memcpy(pV, pTileInfo->pVertex, m_MapInfo.nVertices * sizeof(TERRAINVERTEX));
	pTileInfo->pVB->Unlock();

	return S_OK;
}

HRESULT CTerrain::CreateIB(int LODLevel)
{
	//   ε   ٸ ؾ
	//  1ŸϾȿ   8̸
	// Level 0 = ε (), ε  (1 )
	// Level 1 = ε (/ 4), ε  (2 )
	// Level 2 = ε (/16), ε  (4 )
	// Level 3 =   8   (1ŸϾȿ 2*2    ؼ)
	int level	= (int)pow(4.0f, LODLevel);		//  (1, 4, 16 4  Ŀ Ѵ)
	int size	= m_MapInfo.nIndices / level;	// ε ( 4   Ѵ)
	int next	= (int)pow(2.0f, LODLevel);		//  ؽ Ѿ ũ

	// LOD  ũ ε  ϴ.
	int crackIndex=0;
	for(crackIndex=0; crackIndex<5; ++crackIndex)
	{
		// 0°   ũ ε ۰ ʿǷ н
		if(LODLevel == 0 && crackIndex > 0)
		{
			m_ppIB[LODLevel][crackIndex] = NULL;
			continue;
		}

		// 0 ⺻ ũ ε 
		int indexSize = size;
		if(0 < LODLevel && (1 <= crackIndex && crackIndex < 5))	// 1 ~ 4  cell 3 ﰢ ߰
		{
			//  ڸ  3 ﰢ ߰(1ﰢ 3ε)
			indexSize += (m_MapInfo.nCells / next) * 3 * 3;
		}

		// ε Ÿϸ ̱  1Ÿϸ ؼ Ѵ.
		// , LOD   LOD  ° ε ۸ Ѵ.
		if(FAILED(m_pDevice->CreateIndexBuffer(indexSize * sizeof(WORD),
					0, D3DFMT_INDEX16, D3DPOOL_DEFAULT, &m_ppIB[LODLevel][crackIndex], NULL)))
		{ return E_FAIL; }

		WORD* pI;
		if(FAILED(m_ppIB[LODLevel][crackIndex]->Lock(0, indexSize * sizeof(WORD), (void**)&pI, NULL)))
		{ return E_FAIL; }

		int z=0;
		int x=0;
		int half = next/2;
		for(z=0; z<m_MapInfo.nCells; z+=next)
		{
			for(x=0; x<m_MapInfo.nCells; x+=next)
			{
				// 0--1--2
				// 3--4--5
				// 6--7--8
				int _0 = 	    z * (m_MapInfo.nCells+1) + x;		// 0
				int _1 = 	    z * (m_MapInfo.nCells+1) + x+half;	// 1
				int _2 = 	    z * (m_MapInfo.nCells+1) + x+next;	// 2
				int _3 = (z+half) * (m_MapInfo.nCells+1) + x;		// 3
				int _4 = (z+half) * (m_MapInfo.nCells+1) + x+half;	// 4
				int _5 = (z+half) * (m_MapInfo.nCells+1) + x+next;	// 5
				int _6 = (z+next) * (m_MapInfo.nCells+1) + x;		// 6
				int _7 = (z+next) * (m_MapInfo.nCells+1) + x+half;	// 7
				int _8 = (z+next) * (m_MapInfo.nCells+1) + x+next;	// 8
				
				bool bCheck = false;
				switch(crackIndex)
				{
					case LOD_BASIC:
						bCheck = true;
						break;

				// LEFT
					case LOD_LEFT:
						if(x == 0)
						{
							*pI++ =	_4;		*pI++ = _0;		*pI++ = _2;	// 4, 0, 2
							*pI++ = _4;		*pI++ = _2;		*pI++ = _8;	// 4, 2, 8
							*pI++ = _4;		*pI++ = _8;		*pI++ = _6;	// 4, 8, 6
							*pI++ = _4;		*pI++ = _6;		*pI++ = _3;	// 4, 6, 3
							*pI++ = _4;		*pI++ = _3;		*pI++ = _0;	// 4, 3, 0
							bCheck = false;
						}
						else{ bCheck = true; }
						break;

				// TOP
					case LOD_TOP:
						if(z == 0)
						{
							*pI++ =	_4;		*pI++ = _0;		*pI++ = _1;	// 4, 0, 1
							*pI++ =	_4;		*pI++ = _1;		*pI++ = _2;	// 4, 1, 2
							*pI++ =	_4;		*pI++ = _2;		*pI++ = _8;	// 4, 2, 8
							*pI++ =	_4;		*pI++ = _8;		*pI++ = _6;	// 4, 8, 6
							*pI++ =	_4;		*pI++ = _6;		*pI++ = _0;	// 4, 6, 0
							bCheck = false;
						}
						else{ bCheck = true; }
						break;

				// RIGHT
					case LOD_RIGHT:
						if(x == m_MapInfo.nCells-next)
						{
							*pI++ =	_4;		*pI++ = _0;		*pI++ = _2;	// 4, 0, 2
							*pI++ =	_4;		*pI++ = _2;		*pI++ = _5;	// 4, 2, 5
							*pI++ =	_4;		*pI++ = _5;		*pI++ = _8;	// 4, 5, 8
							*pI++ =	_4;		*pI++ = _8;		*pI++ = _6;	// 4, 8, 6
							*pI++ =	_4;		*pI++ = _6;		*pI++ = _0;	// 4, 6, 0
							bCheck = false;
						}
						else{ bCheck = true; }
						break;			

				// BOTTOM
					case LOD_BOTTOM:
						if(z == m_MapInfo.nCells-next)
						{
							*pI++ =	_4;		*pI++ = _0;		*pI++ = _2;	// 4, 0, 2
							*pI++ =	_4;		*pI++ = _2;		*pI++ = _8;	// 4, 2, 8
							*pI++ =	_4;		*pI++ = _8;		*pI++ = _7;	// 4, 8, 7
							*pI++ =	_4;		*pI++ = _7;		*pI++ = _6;	// 4, 7, 6
							*pI++ =	_4;		*pI++ = _6;		*pI++ = _0;	// 4, 6, 0
							bCheck = false;
						}
						else{ bCheck = true; }
						break;

				} // end case
			
				if(bCheck)
				{
					*pI++ =	_0;		*pI++ = _2;		*pI++ = _6;	// 0, 2, 6
					*pI++ =	_6;		*pI++ = _2;		*pI++ = _8;	// 6, 2, 8
				}
			}
		} // end for

		m_ppIB[LODLevel][crackIndex]->Unlock();
	}

	return S_OK;
}

HRESULT CTerrain::CreateTexture(int index, wchar_t* texName)
{
	// ؽ  Ѿ ̻  Ѵ.
	if(index >= m_MapInfo.nTextureNum)
	{
		return E_FAIL;
	}

	if(m_ppTexture[index] == NULL)
	{
		// ؽ ̸ Ѵ.
		m_strTextureName[index] = texName;

		if(FAILED(D3DXCreateTextureFromFileEx(m_pDevice, texName,
					D3DX_DEFAULT, D3DX_DEFAULT, D3DX_DEFAULT, 0,
					D3DFMT_UNKNOWN, D3DPOOL_MANAGED, D3DX_DEFAULT, D3DX_DEFAULT,
					0, NULL, NULL, &m_ppTexture[index])))
		{
			return E_FAIL;
		}
	}

	return S_OK;
}

HRESULT CTerrain::CreateAlphaTexture(int index)
{
	// D3DFMT_A8R8G8B8(İ  ؽó )
	// ü ؽó ( ũ, ؽ ũƴ)
	if(m_pAlphaTexture[index] == NULL)
	{
		if(FAILED(D3DXCreateTexture(m_pDevice, m_MapInfo.nAlphaTexSize, m_MapInfo.nAlphaTexSize,
					1, 0, D3DFMT_A8R8G8B8, D3DPOOL_MANAGED, &m_pAlphaTexture[index])))
		{
			return E_FAIL;
		}
	}

	D3DLOCKED_RECT alphaTex_Locked;
	::ZeroMemory(&alphaTex_Locked, sizeof(alphaTex_Locked));

	if(FAILED(m_pAlphaTexture[index]->LockRect(0, &alphaTex_Locked, NULL, 0)))
	{
		return E_FAIL;
	}

	BYTE* defBits = (BYTE*)alphaTex_Locked.pBits;

	int i=0;
	int y=0;
	int x=0;
	for(y=0; y<m_MapInfo.nAlphaTexSize; ++y)
	for(x=0; x<m_MapInfo.nAlphaTexSize; ++x)
	{
		// (0x00)  ä.
		defBits[i++] = 0x00;	// B
		defBits[i++] = 0x00;	// G
		defBits[i++] = 0x00;	// R
		defBits[i++] = 0x00;	// A
	}

	if(FAILED(m_pAlphaTexture[index]->UnlockRect(0)))
	{
		return E_FAIL;
	}

	return S_OK;
}

HRESULT CTerrain::ChangeAlphaTexture(int dest, int src)
{
	// src ؽ  dest ؽķ Ѵ.
	D3DLOCKED_RECT alpha_dest, alpha_src;
	::ZeroMemory(&alpha_dest, sizeof(alpha_dest));
	::ZeroMemory(&alpha_src, sizeof(alpha_src));

	if(FAILED(m_pAlphaTexture[dest]->LockRect(0, &alpha_dest, NULL, 0)))
	{
		return E_FAIL;
	}
	if(FAILED(m_pAlphaTexture[src]->LockRect(0, &alpha_src, NULL, 0)))
	{
		return E_FAIL;
	}

	BYTE* defBits_dest	= (BYTE*)alpha_dest.pBits;
	BYTE* defBits_src	= (BYTE*)alpha_src.pBits;

	int i=0;
	int j=0;
	int y=0;
	int x=0;
	for(y=0; y<m_MapInfo.nAlphaTexSize; ++y)
	{
		for(x=0; x<m_MapInfo.nAlphaTexSize; ++x)
		{
			defBits_dest[i++] = defBits_src[j++];	// B
			defBits_dest[i++] = defBits_src[j++];	// G
			defBits_dest[i++] = defBits_src[j++];	// R
			defBits_dest[i++] = defBits_src[j++];	// A
		}
	}

	if(FAILED(m_pAlphaTexture[src]->UnlockRect(0)))
	{
		return E_FAIL;
	}
	if(FAILED(m_pAlphaTexture[dest]->UnlockRect(0)))
	{
		return E_FAIL;
	}

	return S_OK;
}

void CTerrain::DrawBaseTile(int index)
{
	// ؽ Ʈ  
	D3DXMATRIXA16 matTemp;
	D3DXMatrixScaling(&matTemp, 2.0f, 2.0f, 1.0f);
	m_pDevice->SetTextureStageState(0, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_COUNT2);
	m_pDevice->SetSamplerState(0, D3DSAMP_ADDRESSU, D3DTADDRESS_WRAP);
	m_pDevice->SetSamplerState(0, D3DSAMP_ADDRESSV, D3DTADDRESS_WRAP);
	m_pDevice->SetTransform(D3DTS_TEXTURE0, &matTemp);
	m_pDevice->SetTransform(D3DTS_TEXTURE1, &matTemp);

	// ̽ ؽó t1.u, t1.v (0° ؽó ε)
	m_pDevice->SetTextureStageState(0, D3DTSS_TEXCOORDINDEX, 0);
	m_pDevice->SetTextureStageState(0, D3DTSS_COLOROP,   D3DTOP_MODULATE);
  	m_pDevice->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
	m_pDevice->SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);
	m_pDevice->SetTextureStageState(0, D3DTSS_ALPHAOP,   D3DTOP_SELECTARG1);
	m_pDevice->SetTextureStageState(0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE);

	m_pDevice->SetTexture(0, m_ppTexture[m_nTextureIndex[0]]);
	m_pDevice->SetStreamSource(0, m_pTileInfo[index].pVB, 0, sizeof(TERRAINVERTEX));
	m_pDevice->SetFVF(TERRAIN_FVF);
	m_pDevice->SetIndices(m_ppIB[m_pTileInfo[index].nLodLevel][m_pTileInfo[index].nLodCrackIndex]);
	m_pDevice->DrawIndexedPrimitive(D3DPT_TRIANGLELIST, 0, 0, m_MapInfo.nVertices, 0, m_pTileInfo[index].nTriangleNum);

}

void CTerrain::DrawSplattingTile(int index)
{
	for(int i=0; i<m_nSelectTextureNum-1; ++i)
	{
		// ؽ Ʈ  
		m_pDevice->SetTextureStageState(0, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_DISABLE);
		m_pDevice->SetTextureStageState(1, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_COUNT2);
		m_pDevice->SetSamplerState(0, D3DSAMP_ADDRESSU, D3DTADDRESS_CLAMP);
		m_pDevice->SetSamplerState(0, D3DSAMP_ADDRESSV, D3DTADDRESS_CLAMP);
		m_pDevice->SetSamplerState(1, D3DSAMP_ADDRESSU, D3DTADDRESS_WRAP);
		m_pDevice->SetSamplerState(1, D3DSAMP_ADDRESSV, D3DTADDRESS_WRAP);
		
		// texture splatting ⺻ؽ Ŀ ö ؽĴ
		// Ƽؽĸ ̿ؼ 0 ε ĸ 1 ε ̹ Ѵ.
		// 1 ε Į OP ؽĮ ڽ ؽĸ ̿ϸ
		// OP 0ε ĸ ؼ Ѵ.
		//  ؽó t2.u, t2.v (1° ؽó ε)
		m_pDevice->SetTextureStageState(0, D3DTSS_TEXCOORDINDEX, 1);
		m_pDevice->SetTextureStageState(0, D3DTSS_COLOROP,   D3DTOP_SELECTARG1);
		m_pDevice->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
		m_pDevice->SetTextureStageState(0, D3DTSS_ALPHAOP,   D3DTOP_SELECTARG1);
		m_pDevice->SetTextureStageState(0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE);

		m_pDevice->SetTextureStageState(1, D3DTSS_TEXCOORDINDEX, 0);
		m_pDevice->SetTextureStageState(1, D3DTSS_COLOROP,	D3DTOP_MODULATE);
		m_pDevice->SetTextureStageState(1, D3DTSS_COLORARG1, D3DTA_DIFFUSE);
		m_pDevice->SetTextureStageState(1, D3DTSS_COLORARG2, D3DTA_TEXTURE);
		m_pDevice->SetTextureStageState(1, D3DTSS_ALPHAOP,   D3DTOP_SELECTARG1);
		m_pDevice->SetTextureStageState(1, D3DTSS_ALPHAARG1, D3DTA_CURRENT);

		// ⺻  ɼ
		m_pDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
		m_pDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);
		m_pDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);

		m_pDevice->SetTexture(0, m_pAlphaTexture[i]);
		m_pDevice->SetTexture(1, m_ppTexture[m_nTextureIndex[i+1]]);
		m_pDevice->SetStreamSource(0, m_pTileInfo[index].pVB, 0, sizeof(TERRAINVERTEX));
		m_pDevice->SetIndices(m_ppIB[m_pTileInfo[index].nLodLevel][m_pTileInfo[index].nLodCrackIndex]);
		m_pDevice->DrawIndexedPrimitive(D3DPT_TRIANGLELIST, 0, 0, m_MapInfo.nVertices, 0, m_pTileInfo[index].nTriangleNum);
	}

	// Ƽؽ    Ѵ.
	m_pDevice->SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_DISABLE);
	m_pDevice->SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_DISABLE);
	m_pDevice->SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_DISABLE);
	m_pDevice->SetTextureStageState(1, D3DTSS_ALPHAOP, D3DTOP_DISABLE);

    //    Ѵ.
	m_pDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);	
}

void CTerrain::DrawBoundaryLine(int index)
{
	m_pDevice->SetTextureStageState(0, D3DTSS_COLOROP,   D3DTOP_SELECTARG1);
	m_pDevice->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_DIFFUSE);
	m_pDevice->SetRenderState(D3DRS_LIGHTING, FALSE);

	int vertices = m_MapInfo.nCells+1;
	BRUSHVERTEX* line = new BRUSHVERTEX[vertices];
	int i=0;
	for(i=0; i<vertices; ++i)
		line[i].color = COLOR_BOUNDARY;

	//    ( Ʒ  -_-;)
	for(i=0; i<vertices; ++i)
	{
		line[i].p	= m_pTileInfo[index].pVertex[i].p;
		line[i].p.y = GetHeight(line[i].p.x, line[i].p.z) + 0.5f;
	}
	m_pDevice->SetFVF(BRUSHVERTEX::FVF);
	m_pDevice->DrawPrimitiveUP(D3DPT_LINESTRIP, vertices-1, line, sizeof(BRUSHVERTEX));

	//    (   -_-;)
	for(i=0; i<vertices; ++i)
	{
		int next	= (i * vertices) + (m_MapInfo.nCells % vertices);
		line[i].p	= m_pTileInfo[index].pVertex[next].p;
		line[i].p.y = GetHeight(line[i].p.x, line[i].p.z) + 0.5f;
	}
	m_pDevice->SetFVF(BRUSHVERTEX::FVF);
	m_pDevice->DrawPrimitiveUP(D3DPT_LINESTRIP, vertices-1, line, sizeof(BRUSHVERTEX));

	DELS(line);

	m_pDevice->SetRenderState(D3DRS_LIGHTING, TRUE);
}

void CTerrain::DrawTerrain()
{
	if(m_bLight)
		m_pDevice->SetRenderState(D3DRS_LIGHTING, TRUE);
	else
		m_pDevice->SetRenderState(D3DRS_LIGHTING, FALSE);

//	if(m_bFog)
//		m_pDevice->SetRenderState(D3DRS_FOGENABLE, TRUE);
//	else
//		m_pDevice->SetRenderState(D3DRS_FOGENABLE, FALSE);

	if(m_bWireFrame)
		m_pDevice->SetRenderState(D3DRS_FILLMODE, D3DFILL_WIREFRAME);
	else
		m_pDevice->SetRenderState(D3DRS_FILLMODE, D3DFILL_SOLID);

	unsigned int i=0;
	unsigned int j=0;
	for(i=0; i<m_vecVisibleTile.size(); ++i)
	{
		// ̽ ؽ ׸
		DrawBaseTile(m_vecVisibleTile[i]);
	}

	// ÷ ؽ ׸
	// ̴ ŸϾȿ  츸 ׸
	for(i=0; i<m_vecSplattingTile.size(); ++i)
	{
		bool bVisible=false;
		for(j=0; j<m_vecVisibleTile.size(); ++j)
		{
			if(m_vecVisibleTile[j] == m_vecSplattingTile[i])
				bVisible = true;
		}
		if(bVisible)
			DrawSplattingTile(m_vecSplattingTile[i]);
	}

	// 輱 
	for(i=0; i<m_vecVisibleTile.size(); ++i)
	{
		if(m_bBoundaryLine)
			DrawBoundaryLine(m_vecVisibleTile[i]);
	}
}

void CTerrain::SetupLOD(D3DXVECTOR3 look)
{
	// LOD ü ŸϿ  Ѵ.
	// ̴ Ÿϸ ϸ ¿쿡  ʴ Ÿ
	// LOD ׳ 0 ǹǷ η(ũ)   .
	int lod=0;
	for(lod=0; lod<m_MapInfo.nTotalTiles; ++lod)
	{
		// LOD  
		if(m_bApplyLOD)
			GetLODLevel(look, lod);
		else
			m_pTileInfo[lod].nLodLevel = 0;
	}

	unsigned int i=0;
	for(i=0; i<m_vecVisibleTile.size(); ++i)
	{
		// LOD  ° ũ ε 
		if(m_bApplyLOD)
		{
			SetupCrackIndex(m_vecVisibleTile[i]);
		}
		else
		{
			m_pTileInfo[m_vecVisibleTile[i]].nLodCrackIndex	= 0;
			m_pTileInfo[m_vecVisibleTile[i]].nTriangleNum	= m_MapInfo.nTriangles;
		}
	}
}

inline void CTerrain::GetLODLevel(D3DXVECTOR3 look, int index)
{
	// ī޶ Lookġ Ÿ ߽ Ÿ Ѵ.
	// 簢   x z Ѵ.
	// ׳  Ÿ ϸ  LOD µ ׷ ũ 16 ʿϴ.
	// 簢  ũ 4⸸ ʿϴ.
	D3DXVECTOR3 distX(0.0f,0.0f,0.0f);
	distX.x		= look.x - m_pHeightMap[m_pTileInfo[index].nCenter].p.x;
	float LenX	= D3DXVec3Length(&distX);

	D3DXVECTOR3 distZ(0.0f,0.0f,0.0f);
	distZ.z		= look.z - m_pHeightMap[m_pTileInfo[index].nCenter].p.z;
	float LenZ	= D3DXVec3Length(&distZ);

	float Len=0.0f;
	if(LenX >= LenZ)
		Len=LenX;
	else
		Len=LenZ;

	int i=0;
	for(i=0; i<m_nMaxLODLevel; ++i)
	{
		if((float)(i*m_nLODLevelSize) <= Len)
			m_pTileInfo[index].nLodLevel = i;
		else
			break;
	}
}

inline void CTerrain::SetupCrackIndex(int index)
{
	int current	= m_pTileInfo[index].nLodLevel;
	int comp[4] = { 0, };
	int tiles	= m_MapInfo.nTiles;

	// left, up, right, down ˻
	comp[0]	= (index%tiles > 0)		? m_pTileInfo[index-1].nLodLevel	 : m_pTileInfo[index].nLodLevel;
	comp[1]	= (index/tiles > 0)		? m_pTileInfo[index-tiles].nLodLevel : m_pTileInfo[index].nLodLevel;
	comp[2]	= (index%tiles < tiles-1) ? m_pTileInfo[index+1].nLodLevel	 : m_pTileInfo[index].nLodLevel;
	comp[3]	= (index/tiles < tiles-1) ? m_pTileInfo[index+tiles].nLodLevel : m_pTileInfo[index].nLodLevel;

	//  ü LOD  2   Ʒ ﰢ  Ѵ.
	int devide = (int)pow(2.0f, m_pTileInfo[index].nLodLevel);
	int triNum = m_MapInfo.nCells / devide;

	int i=0;
	int count=0;
	for(i=0; i<4; ++i)
	{
		// 3 2 6
		// 1 0 4
		// 9 8 12
		//  ó left ؼ  Ʋ count=1
		// left, up 2 1+2=3 ȴ. up, right 2 2+4=6  ߺ ʴ´.
		//  2 Ʋ   ġ شϴ 밢 ڰ  ȴ.

		// left, up, right, down ϸ鼭 緹 ֺ Ŭ 츸 Ѵ.
		//   Ŭ  η  ϱ ̴.
        if(current <= comp[i])		// 緹 ֺ   
			count += 0;
		else if(current > comp[i])	// 緹 ֺ Ŭ 
			count += (int)pow(2.0f, i);
	}

	// 0, 3, 6, 9, 12  ̿ 
	if(count % 3 == 0)
		count = 0;

	switch(count)
	{
	case 0:
		m_pTileInfo[index].nLodCrackIndex	= LOD_BASIC;
		m_pTileInfo[index].nTriangleNum		= triNum*triNum*2;
		break;

	case 1:
		m_pTileInfo[index].nLodCrackIndex	= LOD_LEFT;
		m_pTileInfo[index].nTriangleNum		= triNum*triNum*2 + (triNum*3);
		break;

	case 2:
		m_pTileInfo[index].nLodCrackIndex	= LOD_TOP;
		m_pTileInfo[index].nTriangleNum		= triNum*triNum*2 + (triNum*3);
		break;

	case 4:
		m_pTileInfo[index].nLodCrackIndex	= LOD_RIGHT;
		m_pTileInfo[index].nTriangleNum		= triNum*triNum*2 + (triNum*3);
		break;

	case 8:
		m_pTileInfo[index].nLodCrackIndex	= LOD_BOTTOM;
		m_pTileInfo[index].nTriangleNum		= triNum*triNum*2 + (triNum*3);
		break;

	default:
		break;
	}
}

inline void CTerrain::TexturePaintInBrushArea()
{
	// 귯 ȿ ִ Ÿϵ Ѵ.
	float maxPos = (float)(m_MapInfo.nTiles * m_MapInfo.nCells * m_MapInfo.nCellSpacing);
	D3DXVECTOR3 left	= m_vPickPos;
	D3DXVECTOR3 right	= m_vPickPos;
	D3DXVECTOR3 up		= m_vPickPos;
	D3DXVECTOR3 down	= m_vPickPos;
	left.x	= m_vPickPos.x - (m_fBrushOutSize * m_MapInfo.nCellSpacing);
	right.x	= m_vPickPos.x + (m_fBrushOutSize * m_MapInfo.nCellSpacing);
	up.z	= m_vPickPos.z + (m_fBrushOutSize * m_MapInfo.nCellSpacing);
	down.z	= m_vPickPos.z - (m_fBrushOutSize * m_MapInfo.nCellSpacing);

	if(left.x <= 0.0f)		{ left.x = 1.0f; }
	if(right.x >= maxPos)		{ right.x = maxPos-1.0f; }
	if(up.z >= 0.0f)			{ up.z = -1.0f; }
	if(down.z <= -(maxPos))	{ down.z = -(maxPos)+1.0f; }

	int curTile		= SearchPositionInTiles(m_vPickPos);
	int leftTile	= SearchPositionInTiles(left);
	int rightTile	= SearchPositionInTiles(right);
	int upTile		= SearchPositionInTiles(up);
	int downTile	= SearchPositionInTiles(down);

	int xStartTile	= upTile - (curTile - leftTile);
	int xTileSize	= xStartTile + rightTile - leftTile;
	int zTileSize	= (downTile/m_MapInfo.nTiles) - (upTile/m_MapInfo.nTiles);

	unsigned int i=0;
	int z=0;
	int x=0;
	int tileIndex=0;
	for(z=0; z<=zTileSize; ++z)
	for(x=xStartTile; x<=xTileSize; ++x)
	{
		// 귯  ŸϹȣ Ѵ.
		tileIndex = x + (z * m_MapInfo.nTiles);

		//   ŸϹȣ ؼ ϸ  ʴ´.
		bool equal=false;
		for(i=0; i<m_vecSplattingTile.size(); ++i)
		{
            if(tileIndex == m_vecSplattingTile[i])
			{
				equal = true;
				break;
			}
		}
		// ο ŸϹȣ  Ѵ.
		if(!equal)
			m_vecSplattingTile.push_back(tileIndex);
	}
}

void CTerrain::MakeAlphaTexture(int index, int brushType)
{
	// 귯 ĥѰ ÷  ϱ
	TexturePaintInBrushArea();

	int mapSize  = m_MapInfo.nTiles * m_MapInfo.nCells * m_MapInfo.nCellSpacing;

	//  μ   ؽó  Ѵ.(1ؼ ũ⸦ Ѵ)
	float texelSize = (float)mapSize / (float)m_MapInfo.nAlphaTexSize;

	// ؽó  귯 ũ⸦ Ѵ.
	int brushSize	= (int)(m_fBrushOutSize*m_MapInfo.nCellSpacing / texelSize);

	//  콺 ġ  ؽó tu, tv Ѵ(0.0f ~ 1.0f)
	float tu =  (m_vPickPos.x / mapSize);
	float tv = -(m_vPickPos.z / mapSize);

	//   tu,tv ̿ؼ ؽó ǥ Ѵ.
	// ؽó 256̸ 0 ~ 255̴.
	int texPosX = (int)(m_MapInfo.nAlphaTexSize * tu);
	int texPosY = (int)(m_MapInfo.nAlphaTexSize * tv);

	// 콺 ġ ߽ -x ~ +x, -y ~ +y ؽó ǥ Ѵ.
	int startX	= ((texPosX - brushSize) < 0) ? 0 : texPosX - brushSize;
	int startY	= ((texPosY - brushSize) < 0) ? 0 : texPosY - brushSize;
	int endX	= ((texPosX + brushSize) >= m_MapInfo.nAlphaTexSize) ? m_MapInfo.nAlphaTexSize : texPosX + brushSize;
	int endY	= ((texPosY + brushSize) >= m_MapInfo.nAlphaTexSize) ? m_MapInfo.nAlphaTexSize : texPosY + brushSize;
	
	D3DLOCKED_RECT alphaTex_Locked;
	::ZeroMemory(&alphaTex_Locked, sizeof(alphaTex_Locked));
	m_pAlphaTexture[index]->LockRect(0, &alphaTex_Locked, NULL, 0);

	BYTE  data;
	BYTE* defBits = (BYTE*)alphaTex_Locked.pBits;

	float outSize	= 0.0f;
	float inSize	= 0.0f;
	if(brushType == 0)		// 귯 Ÿ ϶
	{
		outSize = (float)(m_fBrushOutSize*m_MapInfo.nCellSpacing);
		inSize	= (float)(m_fBrushInSize*m_MapInfo.nCellSpacing);
	}
	else if(brushType == 1)	// 귯 Ÿ 簢϶
	{
		float out	= m_fBrushOutSize*m_MapInfo.nCellSpacing;
		float in	= m_fBrushInSize*m_MapInfo.nCellSpacing;
		outSize		= sqrt((out * out) + (out * out));
		inSize		= sqrt((in * in) + (in * in));
	}
	// 콺 ߽  ȼ 鼭  Ѵ.
	int y=0;
	int x=0;
	for(y=startY; y<endY; ++y)
	for(x=startX; x<endX; ++x)
	{
		// in x*4 İ ġ д´.(BGRA̱⶧)
		int in = (alphaTex_Locked.Pitch * y) + (x * 4);

		// ش ȼ İ о´.
		BYTE read = defBits[in];

		// ؽó 콺 ŷ ġ 3D ǥ ȯϰ,
        // ġ ߽ ʿ, ٱʿ Ÿ Ѵ.
		D3DXVECTOR3 distance = D3DXVECTOR3(x*texelSize, 0.0f, ((m_MapInfo.nAlphaTexSize)-y)*texelSize) -
						 D3DXVECTOR3(texPosX*texelSize, 0.0f, ((m_MapInfo.nAlphaTexSize)-texPosY)*texelSize);

		float length = D3DXVec3Length(&distance);

		if(length <= inSize)	// ȿ 
		{
			data = 0xff; //    (0Xff)
		}
		else if(length <= outSize)	// ūȿ  
		{
			length -= inSize;						//  Ÿ Ѵ.
			int smooth = (int)(outSize - inSize);	// ū   Ÿ Ѵ.

			// 콺 ġ Ÿ ּ  .
			data = (BYTE)((smooth - length) / (float)smooth*0xff);
		}
		else
		{
			// οȿ    ʴ´.
			continue;
		}

		// о ȼ   İ
        // ϱ Ǵ ⿡   Ѵ.
        if(m_nTextureSplatting == 0) 
		{
            read = (read < data) ? data : read;
        }
		else if(m_nTextureSplatting == 1)
		{
            read = ((read - data) < 0x00) ? 0x00 : (read - data);
        }

		// ؽĿ   İ Ѵ.
        // ߿Ѱ A ٲٸ Ǹ, RGB  ٲ ʾƵ ȴ.
		// İ ؽķ ص ȳǷ RGB  ְ ϸ
		// ؽĿ  ȴ.^^
		defBits[in++] = read;	// B
		defBits[in++] = read;	// G
		defBits[in++] = read;	// R
		defBits[in++] = read;	// A
	}

	m_pAlphaTexture[index]->UnlockRect(0);
}

void CTerrain::SaveAlphaValue(int index, BYTE* pRead)
{
	D3DLOCKED_RECT alphaTex_Locked;
	::ZeroMemory(&alphaTex_Locked, sizeof(alphaTex_Locked));

	m_pAlphaTexture[index]->LockRect(0, &alphaTex_Locked, NULL, 0);
	BYTE* defBits = (BYTE*)alphaTex_Locked.pBits;

	int j=0;
	int i=0;
	int y=0;
	int x=0;
	for(y=0; y<m_MapInfo.nAlphaTexSize; ++y)
	for(x=0; x<m_MapInfo.nAlphaTexSize; ++x)
	{
		i += 3;

		// İ Ѵ.
		pRead[j++] = defBits[i++];
	}

	m_pAlphaTexture[index]->UnlockRect(0);
}

void CTerrain::LoadAlphaValue(int index, BYTE* pRead)
{
	D3DLOCKED_RECT alphaTex_Locked;
	::ZeroMemory(&alphaTex_Locked, sizeof(alphaTex_Locked));

	m_pAlphaTexture[index]->LockRect(0, &alphaTex_Locked, NULL, 0);
	BYTE* defBits = (BYTE*)alphaTex_Locked.pBits;

	int j=0;
	int i=0;
	int y=0;
	int x=0;
	for(y=0; y<m_MapInfo.nAlphaTexSize; ++y)
	for(x=0; x<m_MapInfo.nAlphaTexSize; ++x)
	{
		// ߿Ѱ A ٲٸ Ǹ, RGB  ٲ ʾƵ ȴ.
        //  İ Ȯ ؼ    ־Ҵ.
		// İ ؽķ ص ȳǷ RGB  ְ ϸ
		// ؽĿ  ȴ.^^
		defBits[i++] = pRead[j];	// B
		defBits[i++] = pRead[j];	// G
		defBits[i++] = pRead[j];	// R
		defBits[i++] = pRead[j];	// A

		j++;
	}

	m_pAlphaTexture[index]->UnlockRect(0);
}

void CTerrain::SaveAlphaTexture(int index, const wchar_t* pFileName)
{
/********************************************
HRESULT WINAPI
D3DXSaveTextureToFileW(
    LPCWSTR                   pDestFile,
    D3DXIMAGE_FILEFORMAT      DestFormat,
    LPDIRECT3DBASETEXTURE9    pSrcTexture,
    CONST PALETTEENTRY*       pSrcPalette);
********************************************/
	// D3DXIFF_BMP : BMP
	// D3DXIFF_JPG : JPG (İ  ȵ  )
	// D3DXIFF_TGA : TGA
	wchar_t str[128];
	swprintf(str, L"map/alphaTexture/%s%d.bmp", pFileName, index);
	D3DXSaveTextureToFile(str, D3DXIFF_BMP, m_pAlphaTexture[index], NULL);
}

inline void CTerrain::BrushCircleDraw(int count, float size, D3DXCOLOR color)
{
	if(count <= 4)
		count = 4;

	float radian	= D3DX_PI*2.0f / count;
	float brushSize	= size * m_MapInfo.nCellSpacing;	//  * ũ
	
	BRUSHVERTEX	brushLine[2];			// 귯 ؽ[2](2   ׸)
	D3DXVECTOR3 curPos(1.0f,0.0f,0.0f);	// ġ(ʱġ ƹ̳ 1.0f)
	D3DXVECTOR3 newPos;					// ġ(ġ մ´) LINELIST DRAW
	D3DXMATRIX	matRot;					// ġ  ȸ

	// ʱġ[1] (1.0f,0.0f,0.0f) * 귯ũ + ŷ 콺ġ
	brushLine[1].p		= curPos * brushSize + m_vPickPos;
	brushLine[1].p.y	= GetHeight(brushLine[1].p.x, brushLine[1].p.z) + 0.5f;
	brushLine[1].color	= brushLine[0].color = color;
	
	// radian 0  ʱ 1 
	int i=1;
	for(i=1; i<count+1; i++)
	{
		// ó   ġ[1] [0] ְ
		brushLine[0].p = brushLine[1].p;

		// óġ ߽ i*radianŭ ȸ
		// ο ġ ̵ Ϳ ٽ ó[1]ġ ִ´.
		D3DXMatrixRotationY(&matRot, i*radian);
		D3DXVec3TransformCoord(&newPos, &curPos, &matRot);
		D3DXVec3Normalize(&newPos, &newPos);

		// ٽ ο ġ[1] Ѵ.
		brushLine[1].p		= newPos * brushSize + m_vPickPos;
		brushLine[1].p.y	= GetHeight(brushLine[1].p.x, brushLine[1].p.z) + 0.5f;

		// ؽ۸  ʰ ׸(DrawPrimitiveUP)
		m_pDevice->SetFVF(BRUSHVERTEX::FVF);
		m_pDevice->DrawPrimitiveUP(D3DPT_LINELIST, 1, brushLine, sizeof(BRUSHVERTEX));
	}
}

inline void CTerrain::BrushRectangleDraw(int count, float size, D3DXCOLOR color)
{
	if(count <= 4)
		count = 4;

	int quadSize = count/4;
	float brushSize	= size * m_MapInfo.nCellSpacing;	//  * ũ
	
	D3DXVECTOR3 vTL(-1.0f, 0.0f, +1.0f);
	D3DXVECTOR3 vTR(+1.0f, 0.0f, +1.0f);
	D3DXVECTOR3 vBL(-1.0f, 0.0f, -1.0f);
	D3DXVECTOR3 vBR(+1.0f, 0.0f, -1.0f);
	BRUSHVERTEX	brushLine[2];	// 귯 ؽ[2](2   ׸)
	brushLine[0].color = brushLine[1].color = color;
   
	int i=0;
	float t=0.0f;
	D3DXVECTOR3 q1(0.0f, 0.0f, 0.0f);
	D3DXVECTOR3 q2(0.0f, 0.0f, 0.0f);

	// 4  ̸ ѵ  ⿡    ׸.
	int quad=0;
	for(quad=0; quad<4; ++quad)
	{
		switch(quad)
		{
		case 0:	// TL -> TR : ()
			q1 = vTL * brushSize + m_vPickPos;
			q2 = vTR * brushSize + m_vPickPos;
			break;

		case 1:	// TR -> BR : ()
			q1 = vTR * brushSize + m_vPickPos;
			q2 = vBR * brushSize + m_vPickPos;
			break;

		case 2:	// BL -> BR : (Ʒ)
			q1 = vBL * brushSize + m_vPickPos;
			q2 = vBR * brushSize + m_vPickPos;
			break;

		case 3:	// TL -> TR : ()
			q1 = vTL * brushSize + m_vPickPos;
			q2 = vBL * brushSize + m_vPickPos;
			break;
		}
		// count 4  ŭ  .
		// q(t) = (1-t)*q1 + t*q2 :  
		for(i=0; i<quadSize; ++i)
		{
			t = ((float)(i) / (float)quadSize);
			brushLine[0].p		= (1.0f - t)*q1 + (t)*q2;
			brushLine[0].p.y	= GetHeight(brushLine[0].p.x, brushLine[0].p.z) + 0.5f;

			t = ((float)(i+1) / (float)quadSize);
			brushLine[1].p		= (1.0f - t)*q1 + (t)*q2;
			brushLine[1].p.y	= GetHeight(brushLine[1].p.x, brushLine[1].p.z) + 0.5f;
			
			m_pDevice->SetFVF(BRUSHVERTEX::FVF);
			m_pDevice->DrawPrimitiveUP(D3DPT_LINELIST, 1, brushLine, sizeof(BRUSHVERTEX));
		}
	}	
}

void CTerrain::BrushDraw(int count, float outSize, float inSize, D3DXCOLOR outColor, D3DXCOLOR inColor, bool drawInBrush)
{
	if(!m_bPickOk && m_nBrushType == -1)
		return;

	m_fBrushOutSize	= outSize;
	m_fBrushInSize	= inSize;

	m_pDevice->SetTextureStageState(0, D3DTSS_COLOROP,   D3DTOP_SELECTARG1);
	m_pDevice->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_DIFFUSE);
	m_pDevice->SetRenderState(D3DRS_LIGHTING, FALSE);

	if(m_nBrushType == 0)		// 
	{
		if(drawInBrush)
			BrushCircleDraw(count, m_fBrushInSize, inColor);
		BrushCircleDraw(count, m_fBrushOutSize, outColor);
	}
	else if(m_nBrushType == 1)// 簢
	{
		if(drawInBrush)
			BrushRectangleDraw(count, m_fBrushInSize, inColor);
		BrushRectangleDraw(count, m_fBrushOutSize, outColor);
	}

	m_pDevice->SetRenderState(D3DRS_LIGHTING, TRUE);
}

void CTerrain::EditHeightInCircle()
{
	//  1 (ϱ ϱ )
	float fx	=  (m_vPickPos.x / m_MapInfo.nCellSpacing);
	float fz	= -(m_vPickPos.z / m_MapInfo.nCellSpacing);

	int startX	= (int)(fx - m_fBrushOutSize);
	int startZ	= (int)(fz - m_fBrushOutSize);
	int endX	= (int)(fx + m_fBrushOutSize);
	int endZ	= (int)(fz + m_fBrushOutSize);

	if(startX < 0) { startX = 0; }
	if(startZ < 0) { startZ = 0; }
	if(endX >= m_MapInfo.nTotalVertices) { endX = m_MapInfo.nTotalVertices-1; }	// 0 ϱ⶧  -1
	if(endZ >= m_MapInfo.nTotalVertices) { endZ = m_MapInfo.nTotalVertices-1; }	// 0 ϱ⶧  -1

	D3DXVECTOR3 p(0.0f,0.0f,0.0f);
	int z=0;
	int x=0;
	for(z=startZ; z<=endZ; ++z)
	for(x=startX; x<=endX; ++x)
	{
		p = m_pHeightMap[z*m_MapInfo.nTotalVertices+x].p / (float)m_MapInfo.nCellSpacing;
		p.y = 0.0f;

		// 귯 ũ⸸ŭ ġ 콺 ġ Ÿ Ѵ.
		D3DXVECTOR3 Pix = p - (D3DXVECTOR3(m_vPickPos.x, 0.0f, m_vPickPos.z) / (float)m_MapInfo.nCellSpacing);
		float Len = D3DXVec3Length(&Pix);
		
		switch(m_nUpDownMode)
		{
		case UP:
			if(Len <= m_fBrushOutSize)
			{
				float y = -1.0f/(float)m_fBrushOutSize*(Len*Len) + (float)m_fBrushOutSize;
				m_pHeightMap[z*m_MapInfo.nTotalVertices+x].p.y += (y/10.0f) * m_nHeightRate;
			}
			break;

		case DOWN:
			if(Len <= m_fBrushOutSize)
			{
				float y = -1.0f/(float)m_fBrushOutSize*(Len*Len) + (float)m_fBrushOutSize;
				m_pHeightMap[z*m_MapInfo.nTotalVertices+x].p.y -= (y/10.0f) * m_nHeightRate;
			}
			break;

		case FLAT:
			if(Len <= m_fBrushOutSize)
			{				
				m_pHeightMap[z*m_MapInfo.nTotalVertices+x].p.y = m_vPickPos.y;
			}
			break;

		case ORIGIN:
			if(Len <= m_fBrushOutSize)
			{				
				m_pHeightMap[z*m_MapInfo.nTotalVertices+x].p.y = 0.0f;
			}
			break;
		}
	}

	// 귯  1 ġ  ũ Ÿ ˻Ѵ.
	POINT pos[3];
	m_vecBrushAreaTile.clear();
	SearchTileInPickArea(&pos[0], &m_vecBrushAreaTile);

	// ˻ ŸϷ 븻͸ Ѵ.
	ComputeNormal(&pos[0]);

	// ˻ ŸϷ Ѵ.
	unsigned int i=0;
	for(i=0; i<m_vecBrushAreaTile.size(); ++i)
		CreateVB(m_vecBrushAreaTile[i], &m_pTileInfo[m_vecBrushAreaTile[i]]);
}

void CTerrain::EditHeightInRectangle()
{
	// ̱
	//  1 (ϱ ϱ )
	float fx	=  (m_vPickPos.x / m_MapInfo.nCellSpacing);
	float fz	= -(m_vPickPos.z / m_MapInfo.nCellSpacing);

	int startX	= (int)(fx - m_fBrushOutSize);
	int startZ	= (int)(fz - m_fBrushOutSize);
	int endX	= (int)(fx + m_fBrushOutSize);
	int endZ	= (int)(fz + m_fBrushOutSize);

	if(startX < 0) { startX = 0; }
	if(startZ < 0) { startZ = 0; }
	if(endX >= m_MapInfo.nTotalVertices) { endX = m_MapInfo.nTotalVertices-1; }	// 0 ϱ⶧  -1
	if(endZ >= m_MapInfo.nTotalVertices) { endZ = m_MapInfo.nTotalVertices-1; }	// 0 ϱ⶧  -1

	D3DXVECTOR3 p(0.0f,0.0f,0.0f);
	int z=0;
	int x=0;
	for(z=startZ; z<=endZ; ++z)
	for(x=startX; x<=endX; ++x)
	{
		p = m_pHeightMap[z*m_MapInfo.nTotalVertices+x].p / (float)m_MapInfo.nCellSpacing;
		p.y = 0.0f;

		D3DXVECTOR3 axisX(0.0f,0.0f,0.0f);
		axisX.x = ((int)m_vPickPos.x / m_MapInfo.nCellSpacing) - p.x;
		float LenX = D3DXVec3Length(&axisX);

		D3DXVECTOR3 axisZ(0.0f,0.0f,0.0f);
		axisZ.z = ((int)m_vPickPos.z / m_MapInfo.nCellSpacing) - p.z;
		float LenZ = D3DXVec3Length(&axisZ);

		float Len=0.0f;
		if(LenZ >= LenX)
			Len=LenZ;
		else
			Len=LenX;

		switch(m_nUpDownMode)
		{
		case UP:
			if(Len <= m_fBrushOutSize)
			{
				float y = -1.0f/(float)m_fBrushOutSize*(Len*Len) + (float)m_fBrushOutSize;
				m_pHeightMap[z*m_MapInfo.nTotalVertices+x].p.y += (y/30.0f) * m_nHeightRate;
			}
			break;

		case DOWN:
			if(Len <= m_fBrushOutSize)
			{
				float y = -1.0f/(float)m_fBrushOutSize*(Len*Len) + (float)m_fBrushOutSize;
				m_pHeightMap[z*m_MapInfo.nTotalVertices+x].p.y -= (y/30.0f) * m_nHeightRate;
			}
			break;

		case FLAT:
			if(Len <= m_fBrushOutSize)
			{				
				m_pHeightMap[z*m_MapInfo.nTotalVertices+x].p.y = m_vPickPos.y;
			}
			break;

		case ORIGIN:
			if(Len <= m_fBrushOutSize)
			{				
				m_pHeightMap[z*m_MapInfo.nTotalVertices+x].p.y = 0.0f;
			}
			break;
		}
	}

	// 귯  1 ġ  ũ Ÿ ˻Ѵ.
	POINT pos[3];
	m_vecBrushAreaTile.clear();
	SearchTileInPickArea(&pos[0], &m_vecBrushAreaTile);

	// ˻ ŸϷ 븻͸ Ѵ.
	ComputeNormal(&pos[0]);

	// ˻ ŸϷ Ѵ.
	unsigned int i=0;
	for(i=0; i<m_vecBrushAreaTile.size(); ++i)
		CreateVB(m_vecBrushAreaTile[i], &m_pTileInfo[m_vecBrushAreaTile[i]]);
}

inline float CTerrain::Lerp(float a, float b, float t)
{
	return a - (a*t) + (b*t);
}

inline void CTerrain::SearchTileInPickArea(POINT pos[3], vector<int>* pVecTile)
{
	// 귯 ũ⺸ 1ŸϾ  ũ Ѵ.
	//   ˳ϰ ϱ ؼ...
	float tileSize	= (float)(m_MapInfo.nCells * m_MapInfo.nCellSpacing);
	float maxPos	= (float)(m_MapInfo.nTiles * m_MapInfo.nCells * m_MapInfo.nCellSpacing);
	D3DXVECTOR3 left	= m_vPickPos;
	D3DXVECTOR3 right	= m_vPickPos;
	D3DXVECTOR3 up		= m_vPickPos;
	D3DXVECTOR3 down	= m_vPickPos;
	left.x	= m_vPickPos.x - (m_fBrushOutSize * m_MapInfo.nCellSpacing) - tileSize;
	right.x	= m_vPickPos.x + (m_fBrushOutSize * m_MapInfo.nCellSpacing) + tileSize;
	up.z	= m_vPickPos.z + (m_fBrushOutSize * m_MapInfo.nCellSpacing) + tileSize;
	down.z	= m_vPickPos.z - (m_fBrushOutSize * m_MapInfo.nCellSpacing) - tileSize;

	if(left.x <= 0.0f)		{ left.x = 1.0f; }
	if(right.x >= maxPos)		{ right.x = maxPos-1.0f; }
	if(up.z >= 0.0f)			{ up.z = -1.0f; }
	if(down.z <= -(maxPos))	{ down.z = -(maxPos)+1.0f; }

	int curTile		= SearchPositionInTiles(m_vPickPos);
	int leftTile	= SearchPositionInTiles(left);
	int rightTile	= SearchPositionInTiles(right);
	int upTile		= SearchPositionInTiles(up);
	int downTile	= SearchPositionInTiles(down);

	int tile = m_MapInfo.nTiles;
	int xStartTile	= upTile - (curTile - leftTile);
	int xTileSize	= xStartTile + rightTile - leftTile;
	int zTileSize	= (downTile/tile) - (upTile/tile);
	int zEndTile	= xStartTile + ((downTile/tile) - (upTile/tile)) * tile;

	// ŸϹȣ Ѵ.
	// ü ŸϺ  ϱ 
	int z=0;
	int x=0;
	int tileIndex=0;
	for(z=0; z<=zTileSize; ++z)
	for(x=xStartTile; x<=xTileSize; ++x)
	{
		tileIndex = x + (z * tile);
		pVecTile->push_back(tileIndex);
	}

	// 콺ġ ߽ 8߿ ǲ 4 ؽ ǥ Ѵ.
	//   
	POINT edge[3];
	edge[0].x = m_pTileInfo[xStartTile].nEdge[0];
	edge[0].y = m_pTileInfo[xStartTile].nEdge[0];

	edge[1].x = m_pTileInfo[xTileSize].nEdge[1];
	edge[1].y = m_pTileInfo[xTileSize].nEdge[1];

	edge[2].x = m_pTileInfo[zEndTile].nEdge[2];
	edge[2].y = m_pTileInfo[zEndTile].nEdge[2];

	int i=0;
	for(i=0; i<3; ++i)
	{
		pos[i].x = edge[i].x % m_MapInfo.nTotalVertices;
		pos[i].y = edge[i].y / m_MapInfo.nTotalVertices;
	}
}

inline void CTerrain::ComputeNormal(POINT pos[3])
{
	// GPG 3ǿ ִ  ʵ   Ѵ.
	// ڸ  Ѵ.
	float left	= 0.0f;	//   ߽ 
	float right	= 0.0f;	//   ߽ 
	float up	= 0.0f;	//   ߽ 
	float down	= 0.0f;	//   ߽ Ʒ
	D3DXVECTOR3 normal(0.0f,0.0f,0.0f);	//  ͸  ӽú

	// o--A--o	// A 
	// B--M--C	// B , M , C 
	// o--D--o	// D Ʒ
	int z=0;
	int x=0;
	int index = 0;
	for(z=pos[0].y+1; z<pos[2].y-1; ++z) // ̴ Ÿ ( ڸ )
	for(x=pos[0].x+1; x<pos[1].x-1; ++x) // ̴ Ÿ ( ڸ )
	{
		index = z*m_MapInfo.nTotalVertices+x;

		left	= m_pHeightMap[index - 1].p.y;				// ġ ߽  ̰ 
		right	= m_pHeightMap[index + 1].p.y;				// 
		up		= m_pHeightMap[index - m_MapInfo.nTotalVertices].p.y;	// 
		down	= m_pHeightMap[index + m_MapInfo.nTotalVertices].p.y;	// Ʒ

		normal	= D3DXVECTOR3((left-right), 2, (down-up));	//    ʰ   
		D3DXVec3Normalize(&normal, &normal);	// ͷ 

		m_pHeightMap[index].n = normal;			// ̸ʿ 븻 
	}
}

inline float CTerrain::GetHeight(float x, float z)
{
	x =  (x / m_MapInfo.nCellSpacing);
	z = -(z / m_MapInfo.nCellSpacing);

	// 콺 ġ  Ѿ 0.0f 
	if(0.0f >= x || x >= (float)m_MapInfo.nTotalVertices-1 ||
		0.0f >= z || z >= (float)m_MapInfo.nTotalVertices-1)
	{
		return 0.0f;
	}

	// x = 126.75f϶ nx = 126, floorf(x) = 126.000
	int nx = (int)::floorf(x);	// floorf Ҽ ֹ.(ݿø )
	int nz = (int)::floorf(z);

	//  A   B
    //  *---*
    //  | / |
    //  *---*
    //  C   D
	//   yǥ Ѵ.
	float A = m_pHeightMap[    nz * m_MapInfo.nTotalVertices + nx  ].p.y;
	float B = m_pHeightMap[    nz * m_MapInfo.nTotalVertices + nx+1].p.y;
	float C = m_pHeightMap[(nz+1) * m_MapInfo.nTotalVertices + nx  ].p.y;
	float D = m_pHeightMap[(nz+1) * m_MapInfo.nTotalVertices + nx+1].p.y;

	// ó x = 126.75f϶ dx = x(126.75) - nx(126) = 0.75f
	float dx = x - nx;
	float dz = z - nz;

	float height = 0.0f;
	if(dz < 1.0f - dx)  //  ﰢ ABC
	{
		float uy = B - A; // A->B
		float vy = C - A; // A->C

		height = A + Lerp(0.0f, uy, dx) + Lerp(0.0f, vy, dz);
	}
	else // Ʒ ﰢ DCB
	{
		float uy = C - D; // D->C
		float vy = B - D; // D->B

		height = D + Lerp(0.0f, uy, 1.0f - dx) + Lerp(0.0f, vy, 1.0f - dz);
	}

	return height;
}

inline bool CTerrain::IsInVisibleTiles(int tileIndex)
{
	bool InTiles = false;

	// Ʈ  ̴ Ÿϰ  Ÿ ؼ
	// ȿ  true,  false
	unsigned int i=0;
	for(i=0; i<m_vecVisibleTile.size(); ++i)
	{
		if(tileIndex == m_vecVisibleTile[i])
		{
			InTiles = true;
			break;
		}
	}

	return InTiles;
}

inline int CTerrain::SearchPositionInTiles(D3DXVECTOR3 pos, EDGEINFO* pTile)
{
	// ǥ  ŸϹȣ  ʴ´.
	if(pos.x < 0 || pos.z > 0)
		return -1;

	//  ġ Ÿ ȣ Ѵ. 
	int x =  (int)(pos.x * m_MapInfo.nTiles) / m_MapInfo.nTotalMapSize;
	int z = -(int)(pos.z * m_MapInfo.nTiles) / m_MapInfo.nTotalMapSize;

	int tileIndex = (z * m_MapInfo.nTiles + x);

	// Ÿ 𼭸  ǥ ˰ 
	if(pTile != NULL)
	{
		if(0 <= tileIndex && tileIndex < m_MapInfo.nTotalTiles)
		{
			int TL = 0;
			int TR = m_MapInfo.nCells;
			int BL = (m_MapInfo.nCells+1) * ((m_MapInfo.nCells+1) - 1);
			int BR = (m_MapInfo.nCells+1) * (m_MapInfo.nCells+1) - 1;

			pTile->TL = m_pTileInfo[tileIndex].pVertex[TL].p;
			pTile->TR = m_pTileInfo[tileIndex].pVertex[TR].p;
			pTile->BL = m_pTileInfo[tileIndex].pVertex[BL].p;
			pTile->BR = m_pTileInfo[tileIndex].pVertex[BR].p;
		}
	}

	return tileIndex;
}

inline int CTerrain::SearchPositionInMap(D3DXVECTOR3 pos, EDGEINFO* pMap)
{
	// ǥ  ʹȣ  ʴ´.
	if(pos.x < 0 || pos.z > 0)
		return -1;

	int x =  (int)(pos.x * m_MapInfo.nTiles * m_MapInfo.nCells) / m_MapInfo.nTotalMapSize;
	int z = -(int)(pos.z * m_MapInfo.nTiles * m_MapInfo.nCells) / m_MapInfo.nTotalMapSize;

	// m_MapInfo.nTotalVertices = cells * tiles + 1
	int mapIndex = (z * m_MapInfo.nTotalVertices + x);
	int limit	 = (m_MapInfo.nTotalVertices + mapIndex + 1);

	// ڸ Ʒ ؽ  ؽ   ʴ´.
	if(0 <= limit && limit < m_MapInfo.nTotalVertices*m_MapInfo.nTotalVertices)
	{
		pMap->TL = m_pHeightMap[mapIndex].p;
		pMap->TR = m_pHeightMap[mapIndex + 1].p;
		pMap->BL = m_pHeightMap[m_MapInfo.nTotalVertices + mapIndex].p;
		pMap->BR = m_pHeightMap[m_MapInfo.nTotalVertices + mapIndex + 1].p;
	}

	return mapIndex;
}

inline int CTerrain::NearPositionInCells(QUADEDGEINFO* pPart, D3DXVECTOR3 pos, EDGEINFO* pCell, int cellIndex)
{
	// ǥ   ȣ  ʴ´.
	if(pos.x < 0 || pos.z > 0)
		return -1;
//-----------------------------------------------------------------------
//  ġ ߽ ֺ  簢 ߿   ̵Ѵ.
//-----------------------------------------------------------------------
	// m_MapInfo.nTotalVertices = cells * tiles + 1
	int nearCellIndex = 0;
	if((pos.x - pCell->TL.x) <= (m_MapInfo.nCellSpacing / 2))
	{
		// (LEFT TOP)
		if((pos.z - pCell->TL.z) >= -(m_MapInfo.nCellSpacing / 2))
			nearCellIndex = cellIndex;
		// Ʒ(LEFT BOTTOM)
		else
			nearCellIndex = m_MapInfo.nTotalVertices + cellIndex;
	}
	else
	{
		// (RIGHT TOP)
		if((pos.z - pCell->TL.z) >= -(m_MapInfo.nCellSpacing / 2))
			nearCellIndex = cellIndex + 1;
		// Ʒ(RIGHT BOTTOM)
		else
			nearCellIndex = m_MapInfo.nTotalVertices + cellIndex + 1;
	}
	
//-----------------------------------------------------------------------
// 1 迭 Ǿ   ġ  óġ ȴ.
// ׷ ڸ   Ѵ.
// 0-1---------7-8    (0->10, 1->10, 7->16, 8->16) 
// 9-10       16-17   (9->10, 17->16)
// . .         . .
// . .         . .
// 63-64      70-71   (63->64, 71->70)
// 72-73------79-80   (72->64, 73->64, 79->70, 80->70)
// ̷  ̵ؼ ̵  ߽ 簢 4   Ѵ.
//-----------------------------------------------------------------------
	// 0 cell
	if(nearCellIndex == 0)
	{
		nearCellIndex = m_MapInfo.nTotalVertices + 1;
	}
	// 1 ~ γ-1
	else if(1 <= nearCellIndex && nearCellIndex < m_MapInfo.nTotalVertices-1)
	{
		nearCellIndex += m_MapInfo.nTotalVertices;
	}
	// γ
	else if(nearCellIndex == m_MapInfo.nTotalVertices-1)
	{
		nearCellIndex += m_MapInfo.nTotalVertices - 1;
	}
	//   ~  γ -1
	else if(nearCellIndex % m_MapInfo.nTotalVertices == 0)
	{
		nearCellIndex += 1;
	}
	//   ~  γ -1
	else if(nearCellIndex % m_MapInfo.nTotalVertices == m_MapInfo.nTotalVertices-1)
	{
		nearCellIndex -= 1;
	}
	//  Ʒ
	else if(nearCellIndex == m_MapInfo.nTotalVertices * (m_MapInfo.nTotalVertices-1))
	{
		nearCellIndex -= m_MapInfo.nTotalVertices + 1;
	}
	//  Ʒ
	else if(nearCellIndex == m_MapInfo.nTotalVertices * m_MapInfo.nTotalVertices - 1)
	{
		nearCellIndex -= m_MapInfo.nTotalVertices - 1;
	}
	// Ʒ
	else if(nearCellIndex >= m_MapInfo.nTotalVertices * (m_MapInfo.nTotalVertices-1) &&
			 nearCellIndex <  m_MapInfo.nTotalVertices * m_MapInfo.nTotalVertices - 1)
	{
		nearCellIndex -= m_MapInfo.nTotalVertices;
	}

	//    ߽ 4 簢 .
	// m_MapInfo.nTotalVertices = cells * tiles + 1
	int leftTop		= nearCellIndex - m_MapInfo.nTotalVertices - 1;
	int top			= nearCellIndex - m_MapInfo.nTotalVertices;
	int rightTop	= nearCellIndex - m_MapInfo.nTotalVertices + 1;
	int left		= nearCellIndex - 1;
	int center		= nearCellIndex;
	int right		= nearCellIndex + 1;
	int leftBottom	= nearCellIndex + m_MapInfo.nTotalVertices - 1;
	int bottom		= nearCellIndex + m_MapInfo.nTotalVertices;
	int rightBottom	= nearCellIndex + m_MapInfo.nTotalVertices + 1;

	//  Ʒ ؽ հ踦  ʰ Ѵ.
	if(rightBottom < m_MapInfo.nTotalVertices * m_MapInfo.nTotalVertices)
	{
		pPart->part[0].TL = m_pHeightMap[leftTop].p;
		pPart->part[0].TR = m_pHeightMap[top].p;
		pPart->part[0].BL = m_pHeightMap[left].p;
		pPart->part[0].BR = m_pHeightMap[center].p;

		pPart->part[1].TL = m_pHeightMap[top].p;
		pPart->part[1].TR = m_pHeightMap[rightTop].p;
		pPart->part[1].BL = m_pHeightMap[center].p;
		pPart->part[1].BR = m_pHeightMap[right].p;

		pPart->part[2].TL = m_pHeightMap[left].p;
		pPart->part[2].TR = m_pHeightMap[center].p;
		pPart->part[2].BL = m_pHeightMap[leftBottom].p;
		pPart->part[2].BR = m_pHeightMap[bottom].p;

		pPart->part[3].TL = m_pHeightMap[center].p;
		pPart->part[3].TR = m_pHeightMap[right].p;
		pPart->part[3].BL = m_pHeightMap[bottom].p;
		pPart->part[3].BR = m_pHeightMap[rightBottom].p;
	}

	return nearCellIndex;
}

void CTerrain::PickTerrain(CPick* pPick)
{
	//  ī޶ ġ  Ÿ Ѵ.
	int cameraInTiles = SearchPositionInTiles(pPick->m_vPickRayOrig);

	//  ī޶ ġ ŸϾ  Ѵ.
	EDGEINFO currentMapPosition;
	int cameraInMap	= SearchPositionInMap(pPick->m_vPickRayOrig, &currentMapPosition);

	//  ī޶ ġ ߽   ̵
	// ̿ 4 簢(4) Ѵ.
	QUADEDGEINFO currentPart;
	int currentCells = NearPositionInCells(&currentPart, pPick->m_vPickRayOrig, &currentMapPosition, cameraInMap);

	//  ī޶ ġ 콺 ǥ ̿ؼ ⺤͸ .
	D3DXVECTOR3 cameraPos = pPick->m_vPickRayOrig;
	cameraPos.y = 0.0f;
	D3DXVECTOR3 cameraDir = pPick->m_vPickRayOrig + pPick->m_vPickRayDir * 1000;
	cameraDir.y = 0.0f;

	int i=0;
	m_bPickOk = FALSE;
	for(i=0; i<100; ++ i)
	{
		//  ī޶ ġ      ġ Ѵ.
		D3DXVECTOR3 nextPos = cameraDir - cameraPos;
		D3DXVec3Normalize(&nextPos, &nextPos);
		nextPos *= (float)(m_MapInfo.nCellSpacing * 2.0f * i);
		nextPos += cameraPos;

		//   ġ ŸϹȣ Ѵ.
		int nextTileIndex = SearchPositionInTiles(nextPos);
	
		//   ġ ʹȣ Ѵ.
		EDGEINFO nextPosition;
		int nextMapIndex	= SearchPositionInMap(nextPos, &nextPosition);

		// ʹȣ ߽   ̵ 4 簢(4) Ѵ.
		QUADEDGEINFO nextPart;
		int nextCellIndex	= NearPositionInCells(&nextPart, nextPos, &nextPosition, nextMapIndex);

		int j=0;
		for(j=0; j<4; ++j)
		{
			// 0 = nextPart.part[j].TL
			// 1 = nextPart.part[j].TR
			// 2 = nextPart.part[j].BL
			// 3 = nextPart.part[j].BR
			// 簢  ﰢ Ѵ.(0, 1, 2)
			float dist = 0.0f;
			if(pPick->IntersectTriangle(nextPart.part[j].TL, nextPart.part[j].TR, nextPart.part[j].BL, dist))
			{
				m_vPickPos	= pPick->m_vPickRayOrig + pPick->m_vPickRayDir * dist;
				m_bPickOk	= TRUE;
				break;
			}
			// 簢 Ʒ ﰢ Ѵ.(2, 1 ,3)
			if(pPick->IntersectTriangle(nextPart.part[j].BL, nextPart.part[j].TR, nextPart.part[j].BR, dist))
			{
				m_vPickPos	= pPick->m_vPickRayOrig + pPick->m_vPickRayDir * dist;
				m_bPickOk	= TRUE;
				break;
			}
		}

		//   ŷ Ǹ .(͵  ӵ ^^;)
		if(m_bPickOk)
			break;
	}
}