// DlgCreateNewMap.cpp : implementation file
//

#include "stdafx.h"
#include "MapTool_3D.h"
#include "DlgCreateNewMap.h"
#include "../DirectX/MapTool_Mgr.h"

// CDlgCreateNewMap dialog

IMPLEMENT_DYNAMIC(CDlgCreateNewMap, CDialog)

CDlgCreateNewMap::CDlgCreateNewMap(int* pCellNum, int* pCellSpacing, int* pBaseTexture, 
								CStringList* pStrTextureList, CWnd* pParent /*=NULL*/)
	: CDialog(CDlgCreateNewMap::IDD, pParent)
	, m_strTotalMapSize(_T("0 x 0"))
	, m_nTotalVertex_static(0)
	, m_nTotalDistance_static(0)
	, m_nTotalTriangles_static(0)
	, m_CellSpace_static(25)
	, m_MapSize(-1)
	, m_TileSize(-1)
{
	m_nTotalMapSize		= 0;
	m_pCellNum			= pCellNum;
	m_pCellSpacing		= pCellSpacing;
	m_pBaseTexture		= pBaseTexture;
	m_pStrTextureList	= pStrTextureList;
}

CDlgCreateNewMap::~CDlgCreateNewMap()
{
}

void CDlgCreateNewMap::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_STATIC_MAPSIZE, m_strTotalMapSize);
	DDX_Text(pDX, IDC_STATIC_VERTEX, m_nTotalVertex_static);
	DDX_Text(pDX, IDC_STATIC_DISTANCE, m_nTotalDistance_static);
	DDX_Text(pDX, IDC_STATIC_TRIANGLES, m_nTotalTriangles_static);
	DDX_Text(pDX, IDC_STATIC_CELLSPACE, m_CellSpace_static);
	DDX_Control(pDX, IDC_SLIDER_CELLSPACE, m_CellSpace_slider);
	DDX_Control(pDX, IDC_LIST_DLG_TEXTUER, m_ctrlTextureList);
	DDX_Radio(pDX, IDC_COUNT_TILE1, m_MapSize);
	DDX_Radio(pDX, IDC_COUNT_CELL1, m_TileSize);
}


BEGIN_MESSAGE_MAP(CDlgCreateNewMap, CDialog)
	ON_BN_CLICKED(IDOK, &CDlgCreateNewMap::OnBnClickedOk)
	ON_BN_CLICKED(IDC_COUNT_TILE1, &CDlgCreateNewMap::OnBnClickedCountTile1)
	ON_BN_CLICKED(IDC_COUNT_TILE2, &CDlgCreateNewMap::OnBnClickedCountTile2)
	ON_BN_CLICKED(IDC_COUNT_TILE3, &CDlgCreateNewMap::OnBnClickedCountTile3)
	ON_BN_CLICKED(IDC_COUNT_CELL1, &CDlgCreateNewMap::OnBnClickedCountCell1)
	ON_BN_CLICKED(IDC_COUNT_CELL2, &CDlgCreateNewMap::OnBnClickedCountCell2)
	ON_BN_CLICKED(IDC_COUNT_CELL3, &CDlgCreateNewMap::OnBnClickedCountCell3)
	ON_BN_CLICKED(IDCANCEL, &CDlgCreateNewMap::OnBnClickedCancel)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER_CELLSPACE, &CDlgCreateNewMap::OnNMCustomdrawSliderCellspace)
	ON_LBN_SELCHANGE(IDC_LIST_DLG_TEXTUER, &CDlgCreateNewMap::OnLbnSelchangeListDlgTextuer)
	ON_WM_PAINT()
END_MESSAGE_MAP()


// CDlgCreateNewMap message handlers

void CDlgCreateNewMap::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	if(m_MapSize < 0)
	{
		AfxMessageBox(L"Ÿ  ϼ");
		return;
	}
	if(m_TileSize < 0)
	{
		AfxMessageBox(L"  ϼ");
		return;
	}
	if(m_CellSpace_static < 10 || m_CellSpace_static > 30)
	{
		AfxMessageBox(L"  10 ~ 30 ̷ Էϼ");
		return;
	}
	if(m_ctrlTextureList.GetCurSel() < 0)
	{
		AfxMessageBox(L"⺻ ؽĸ ϼ");
		return;
	}

	switch(m_TileSize)
	{
		case 0:	 m_TileSize =  4; break;
		case 1:	 m_TileSize =  8; break;
		case 2:	 m_TileSize = 16; break;
	}

	*m_pCellNum		= m_TileSize;
	*m_pCellSpacing = m_CellSpace_static;
	*m_pBaseTexture = m_ctrlTextureList.GetCurSel();

	// new map ̾˷α׿ ִ ̸ ̽ Ѵ.
	if(g_ToolManager.m_pDirect3D)
		g_ToolManager.m_pDirect3D->ReleasePreview();

	this->EndDialog(m_MapSize);
}

void CDlgCreateNewMap::OnBnClickedCancel()
{
	// TODO: Add your control notification handler code here
	if(g_ToolManager.m_pDirect3D)
		g_ToolManager.m_pDirect3D->ReleasePreview();

	this->EndDialog(-1);
}

BOOL CDlgCreateNewMap::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Ʈڽ ؽó ߰Ѵ.
	POSITION pos;
	pos = m_pStrTextureList->GetHeadPosition();
	for(int i=0; i<m_pStrTextureList->GetCount(); ++i)
	{
		m_ctrlTextureList.AddString(m_pStrTextureList->GetNext(pos));
	}
	
	m_ctrlTextureList.SetCurSel(9);
	m_MapSize			= -1;
	m_TileSize			= -1;
	m_CellSpace_static	= 20;

	m_CellSpace_slider.SetRange(10, 30);
	m_CellSpace_slider.SetPos((int)m_CellSpace_static);
	m_CellSpace_slider.SetTicFreq(1);

	// ̾˷α׿  Ʈ ڵ  ´.
	HWND hWnd;
	GetDlgItem(IDC_NEWMAP_PREVIEW, &hWnd);
	CStatic *staticSize = (CStatic *)GetDlgItem(IDC_NEWMAP_PREVIEW);
	CRect rect;
	staticSize->GetClientRect(rect);
	
	int width  = rect.Width();
	int height = rect.Height();

	// ̸⸦ Ѵ.
	if(g_ToolManager.m_pDirect3D)
	{
		g_ToolManager.m_pDirect3D->InitPreview(hWnd, width, height);

		POSITION pos = m_pStrTextureList->FindIndex(m_ctrlTextureList.GetCurSel());
		CString FileName = L"map/texture/";
		FileName += m_pStrTextureList->GetNext(pos);
		g_ToolManager.m_pDirect3D->LoadPreviewTexture((wchar_t *)FileName.operator LPCTSTR());
	}
	
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
}

void CDlgCreateNewMap::OnLbnSelchangeListDlgTextuer()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	Invalidate(FALSE);

	POSITION pos = m_pStrTextureList->FindIndex(m_ctrlTextureList.GetCurSel());
	CString FileName = L"map/texture/";
	FileName += m_pStrTextureList->GetNext(pos);
	g_ToolManager.m_pDirect3D->LoadPreviewTexture((wchar_t *)FileName.operator LPCTSTR());
}

void CDlgCreateNewMap::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO: Add your message handler code here
	// Do not call CDialog::OnPaint() for painting messages
	if(g_ToolManager.m_pDirect3D)
		g_ToolManager.m_pDirect3D->RenderPreview();
}

//   ũ  
void CDlgCreateNewMap::Compute_Value(int tile, int cell)
{
	switch(m_MapSize)
	{
		case 0:	 tile =  8; break;
		case 1:	 tile = 16; break;
		case 2:	 tile = 32; break;
		default: tile =  1; break;
	}
	switch(m_TileSize)
	{
		case 0:	 cell =  4; break;
		case 1:	 cell =  8; break;
		case 2:	 cell = 16; break;
		default: cell =  1; break;
	}
	m_nTotalMapSize	= tile * cell;
	m_strTotalMapSize.Format(L"%d x %d", m_nTotalMapSize, m_nTotalMapSize);
	m_nTotalDistance_static	= tile * cell * m_CellSpace_static;
	m_nTotalVertex_static	= (tile * cell + 1) * (tile * cell + 1);
	m_nTotalTriangles_static= (tile * cell) * (tile * cell) * 2;

	UpdateData(FALSE);
}

void CDlgCreateNewMap::OnNMCustomdrawSliderCellspace(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: Add your control notification handler code here
	*pResult = 0;

	m_CellSpace_static = m_CellSpace_slider.GetPos();

	Compute_Value(1,1);	
	*pResult = 0;
}

void CDlgCreateNewMap::OnBnClickedCountTile1()
{
	// TODO: Add your control notification handler code here
	m_MapSize = 0;
	Compute_Value(8,1);
}

void CDlgCreateNewMap::OnBnClickedCountTile2()
{
	// TODO: Add your control notification handler code here
	m_MapSize = 1;
	Compute_Value(16,1);
}

void CDlgCreateNewMap::OnBnClickedCountTile3()
{
	// TODO: Add your control notification handler code here
	m_MapSize = 2;
	Compute_Value(32,1);
}

void CDlgCreateNewMap::OnBnClickedCountCell1()
{
	// TODO: Add your control notification handler code here
	m_TileSize = 0;
	Compute_Value(1,4);
}

void CDlgCreateNewMap::OnBnClickedCountCell2()
{
	// TODO: Add your control notification handler code here
	m_TileSize = 1;
	Compute_Value(1,8);
}

void CDlgCreateNewMap::OnBnClickedCountCell3()
{
	// TODO: Add your control notification handler code here
	m_TileSize = 2;
	Compute_Value(1,16);
}

BOOL CDlgCreateNewMap::PreTranslateMessage(MSG* pMsg)
{
	// TODO: Add your specialized code here and/or call the base class
	if(pMsg->message == WM_KEYDOWN)
	{
		switch(pMsg->wParam)
		{
			case VK_ESCAPE:
			case VK_RETURN:
			return TRUE;

			default:
			break;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}