// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "MapTool_3D.h"
#include "MapTool_3DDoc.h"
#include "MapTool_3DView.h"
#include "../Menu/Child_MenuCtrl.h"
#include "MainFrm.h"

#include "DlgCreateNewMap.h"

#include "../DirectX/MapTool_Mgr.h"
#include "../DirectX/Terrain.h"
#include "../DirectX/DecodeSOF.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


BEGIN_MESSAGE_MAP(CSplitterX, CSplitterWnd)
	ON_WM_NCHITTEST()
END_MESSAGE_MAP()

CSplitterX::CSplitterX() {}
CSplitterX::~CSplitterX(){}

LRESULT CSplitterX::OnNcHitTest(CPoint point)
{
	return HTNOWHERE;
}

// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_COMMAND(ID_FILE_NEW, &CMainFrame::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, &CMainFrame::OnFileOpen)
	ON_COMMAND(ID_FILE_SAVE, &CMainFrame::OnFileSave)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};


// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	//-------------------------------------------------------
	// ؽó  
	//  jpg  
	//-------------------------------------------------------
	CFileFind textureFile;
	CString	FileName	= L"";
	CString	strFilePath = L"map/texture/*.jpg";
		
	BOOL bFind;
	bFind = textureFile.FindFile(strFilePath);

	while(bFind)
	{
		bFind = textureFile.FindNextFile();

		if(!textureFile.IsDots() && !textureFile.IsDirectory())
		{
			FileName = textureFile.GetFileName();
			m_strTextureList.AddTail(FileName);
		}
	}

	return 0;
}

BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT /*lpcs*/,
	CCreateContext* pContext)
{
	/*
	̷   䰡  پ  ڵ 
	|-----------------------------|
	|      |                      |
	|child |                      |
	| (0,0)|                      |
	|------|        work          |
	|      |                      |
	|child |                      |
	| (1,0)|                      |
	|      |                      |
	|      |                      |
	|-----------------------------|

	*/

	// ø   
	m_wndSplit_Window.CreateStatic(this, 1, 2);

	//   ٿֱ
	m_wndSplit_Window.CreateView(0, 0, RUNTIME_CLASS(CChild_MenuCtrl), CSize(0, 0), pContext);
	m_wndSplit_Window.CreateView(0, 1, RUNTIME_CLASS(CMapTool_3DView), CSize(0, 0), pContext);

	//  ֱ
	m_wndSplit_Window.SetColumnInfo(0, 300, 0);

	// ϵ  ȣ   
	m_pChd_Menu	= (CChild_MenuCtrl *) m_wndSplit_Window.GetPane(0,0);
	m_pChd_Menu->pFrame = this;
	m_pWorkView	= (CMapTool_3DView *) m_wndSplit_Window.GetPane(0,1);

	return TRUE;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if(!CFrameWnd::PreCreateWindow(cs))
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.style &= ~FWS_ADDTOTITLE;		//ŸƲҼְش
	LPCTSTR TitleName = L"3D Maptool project, since 2010-2-13";	//LPCTSTR ڵ
	SetTitle(TitleName); 

	return TRUE;
}


// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


// CMainFrame message handlers




void CMainFrame::OnFileNew()
{
	// TODO: Add your command handler code here
	int cellNum		= 8;
	int cellSpacing = 10;
	int baseTexture = -1;

	// â   Է    ԷµǸ
	// Ÿϰ, , , ̽ؽó, ؽóƮ ´.
	CDlgCreateNewMap DlgNewMap(&cellNum, &cellSpacing, &baseTexture, &m_strTextureList);
	int tileNum = (int)DlgNewMap.DoModal();

	if(tileNum > -1)
	{
		switch(tileNum)
		{
			case 0: tileNum =  8; break;
			case 1: tileNum = 16; break;
			case 2: tileNum = 32; break;
		}	

		g_ToolManager.DeleteMap();
	
		m_pChd_Menu->m_Menu_Att->Reset();
		m_pChd_Menu->m_Menu_Att->GetPreviewHandle();

		g_pTerrain->InitTerrain(tileNum, cellNum, cellSpacing, (int)m_strTextureList.GetCount(), baseTexture);
		g_ToolManager.CameraSetting();
		TextureLoad();
		
		m_pChd_Menu->Update();

		g_ToolManager.CreateMap();
		g_ToolManager.InitTexturePreview();
	}
	else if(tileNum == -1) //  ⸦  
	{
		//   Ǿ ִ  ̸⸦ ٽ Ѵ.
		//   Ǿ     ʴ´.
		if(g_pTerrain)
		{
			m_pChd_Menu->m_Menu_Att->GetPreviewHandle();
			g_ToolManager.InitTexturePreview();
		}
	}
}

void CMainFrame::OnFileOpen()
{
	// TODO: Add your command handler code here
	wchar_t szFilter[] = L"MapFile (*.SOF) | *.SOF; | All Files(*.*)|*.*||";
	CFileDialog dlg(TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_NOCHANGEDIR, szFilter);

	if(IDOK == dlg.DoModal())
	{
		CString strPathName = dlg.GetPathName();
		
		g_ToolManager.DeleteMap();
		m_pChd_Menu->m_Menu_Att->Reset();
		m_pChd_Menu->m_Menu_Att->GetPreviewHandle();

		CDecodeSOF SOFMapFile;
		SOFMapFile.LodeSOF(strPathName.operator LPCTSTR(), g_pTerrain);

		g_ToolManager.CameraSetting();
		TextureLoad();		

		for(int i=0; i<g_pTerrain->m_nSelectTextureNum; ++i)
		{
			POSITION pos = m_strTextureList.FindIndex(g_pTerrain->m_nTextureIndex[i]);
			m_pChd_Menu->m_Menu_Att->m_ctrlSelectTexture.AddString(m_strTextureList.GetNext(pos));
			m_pChd_Menu->m_Menu_Att->m_nSelectTextureIndex[i] = g_pTerrain->m_nTextureIndex[i];
		}

		m_pChd_Menu->Update();

		g_ToolManager.CreateMap();
		g_ToolManager.InitTexturePreview();
	}
}

void CMainFrame::OnFileSave()
{
	// TODO: Add your command handler code here
	if(g_pTerrain == NULL)
	{
		AfxMessageBox(L"  ϴ..");
		return;
	}

	wchar_t szFilter[] = L"MapFile (*.SOF) | *.SOF; | All Files(*.*)|*.*||";
	CFileDialog dlg(FALSE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_NOCHANGEDIR, szFilter);

	if(IDOK == dlg.DoModal())
	{
		CString strFormatName = L".SOF";
		CString strPathName = dlg.GetPathName();

		//  4ڰ .SOF   ڿ .SOF δ.
		if(strPathName.Right(4) != strFormatName)
			strPathName += strFormatName;

		CDecodeSOF SOFMapFile;
		SOFMapFile.SaveSOF(strPathName.operator LPCTSTR(), g_pTerrain);
	}
}

void CMainFrame::TextureLoad()
{
	CString FileName = L"";
	CString strTexturePath = L"map/texture/";
	POSITION pos;
	pos = m_strTextureList.GetHeadPosition();

	for(int i=0; i<m_strTextureList.GetCount(); ++i)
	{
		FileName = strTexturePath;
		FileName += m_strTextureList.GetNext(pos);
		g_pTerrain->CreateTexture(i, (wchar_t *)FileName.operator LPCTSTR());
	}
}
