// MapTool_3DView.cpp : implementation of the CMapTool_3DView class
//

#include "stdafx.h"
#include "MapTool_3D.h"
#include "MainFrm.h"
#include "MapTool_3DDoc.h"
#include "MapTool_3DView.h"

#include "../MENU/Child_MenuCtrl.h"
#include "../DirectX/MapTool_Mgr.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#endif



// CMapTool_3DView

IMPLEMENT_DYNCREATE(CMapTool_3DView, CView)

BEGIN_MESSAGE_MAP(CMapTool_3DView, CView)
	ON_WM_KEYDOWN()
	ON_WM_TIMER()
	ON_WM_CREATE()
	ON_WM_DESTROY()
END_MESSAGE_MAP()

// CMapTool_3DView construction/destruction

CMapTool_3DView::CMapTool_3DView()
{
	// TODO: add construction code here
	m_nWidth  = 0;
	m_nHeight = 0;
}

CMapTool_3DView::~CMapTool_3DView()
{
}

BOOL CMapTool_3DView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	
	return CView::PreCreateWindow(cs);
}

// CMapTool_3DView drawing

void CMapTool_3DView::OnDraw(CDC* /*pDC*/)
{
	CMapTool_3DDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: add draw code for native data here
}


// CMapTool_3DView diagnostics

#ifdef _DEBUG
void CMapTool_3DView::AssertValid() const
{
	CView::AssertValid();
}

void CMapTool_3DView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMapTool_3DDoc* CMapTool_3DView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMapTool_3DDoc)));
	return (CMapTool_3DDoc*)m_pDocument;
}
#endif //_DEBUG

HRESULT CMapTool_3DView::InitToolManager(HWND hWnd, HINSTANCE hInst, int width, int height)
{
	m_nWidth  = width;
	m_nHeight = height;

	if(FAILED(g_ToolManager.Init(hWnd, hInst, width, height)))
	{
		return E_FAIL;
	}
    
	return S_OK;
}

// CMapTool_3DView message handlers
void CMapTool_3DView::Render(float timeDelta)
{
	g_ToolManager.FrameMove(timeDelta);
}

void CMapTool_3DView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	// TODO: Add your message handler code here and/or call default
	if(!g_pTerrain)
		return;
	
	CMainFrame *pFr = (CMainFrame *)AfxGetMainWnd();
	CMenu_EditMap *pEdit = pFr->m_pChd_Menu->m_Menu_EditMap;

	if(nChar >= VK_F1 && nChar <= VK_F6)
	{
		pFr->m_pChd_Menu->m_Menu_EditMap->ShowWindow(SW_HIDE);
		pFr->m_pChd_Menu->m_Menu_Att->ShowWindow(SW_HIDE);
		pFr->m_pChd_Menu->m_Menu_Object->ShowWindow(SW_HIDE);
		pFr->m_pChd_Menu->m_Menu_Player->ShowWindow(SW_HIDE);
		pFr->m_pChd_Menu->m_Menu_Water->ShowWindow(SW_HIDE);
		pFr->m_pChd_Menu->m_Menu_Particle->ShowWindow(SW_HIDE);
	}
	switch(nChar)
	{
	case VK_F1:
		pFr->m_pChd_Menu->m_MenuTab.SetCurSel(0);
		pFr->m_pChd_Menu->m_Menu_EditMap->ShowWindow(SW_SHOW);
		break;

	case VK_F2:
		pFr->m_pChd_Menu->m_MenuTab.SetCurSel(1);
		pFr->m_pChd_Menu->m_Menu_Att->ShowWindow(SW_SHOW);
		break;

	case VK_F3:
		pFr->m_pChd_Menu->m_MenuTab.SetCurSel(2);
		pFr->m_pChd_Menu->m_Menu_Object->ShowWindow(SW_SHOW);
		break;

	case VK_F4:
		pFr->m_pChd_Menu->m_MenuTab.SetCurSel(3);
		pFr->m_pChd_Menu->m_Menu_Player->ShowWindow(SW_SHOW);
		break;

	case VK_F5:
		pFr->m_pChd_Menu->m_MenuTab.SetCurSel(4);
		pFr->m_pChd_Menu->m_Menu_Water->ShowWindow(SW_SHOW);
		break;

	case VK_F6:
		pFr->m_pChd_Menu->m_MenuTab.SetCurSel(5);
		pFr->m_pChd_Menu->m_Menu_Particle->ShowWindow(SW_SHOW);
		break;

	case VK_F10:
		{
			int selectTextureNum = g_pTerrain->m_nSelectTextureNum;
			for(int i=0; i<selectTextureNum-1; ++i)
			{
				g_pTerrain->SaveAlphaTexture(i, L"AlphaTexture_");
			}
		}
		break;

	case VK_F11:
		g_pTerrain->m_bFrustumLock = !g_pTerrain->m_bFrustumLock;
		break;
	}
	
	// ٱ 귯 ũ
	if(nChar == 219 && pEdit->m_nBrushType > -1) // "[" KEY
	{
		if(pEdit->m_nOutBrush_static > 1)
		{
			pEdit->m_nOutBrush_static--;
			pEdit->m_ctrlOutBrush.SetPos(pEdit->m_nOutBrush_static);

			if(pEdit->m_ctrlOutBrush.GetPos() <= pEdit->m_ctrlInBrush.GetPos())
			{
				pEdit->m_ctrlInBrush.SetPos(pEdit->m_nOutBrush_static);
			}
		}
	}
	if(nChar == 221 && pEdit->m_nBrushType > -1) // "]" KEY
	{
		if(pEdit->m_nOutBrush_static < pEdit->m_ctrlOutBrush.GetRangeMax())
		{
			pEdit->m_nOutBrush_static++;
			pEdit->m_ctrlOutBrush.SetPos(pEdit->m_nOutBrush_static);
		}
	}

	//  귯 ũ
	if(nChar == 79 && pEdit->m_nBrushType > -1)	// "O" KEY
	{
		if(pEdit->m_nInBrush_static > 1)
		{
			pEdit->m_nInBrush_static--;
			pEdit->m_ctrlInBrush.SetPos(pEdit->m_nInBrush_static);
		}
	}
	if(nChar == 80 && pEdit->m_nBrushType > -1)	// "P" KEY
	{
		if(pEdit->m_nInBrush_static < pEdit->m_ctrlInBrush.GetRangeMax())
		{
			pEdit->m_nInBrush_static++;
			pEdit->m_ctrlInBrush.SetPos(pEdit->m_nInBrush_static);
			if(pEdit->m_ctrlOutBrush.GetPos() <= pEdit->m_ctrlInBrush.GetPos())
			{
				pEdit->m_ctrlOutBrush.SetPos(pEdit->m_nInBrush_static);
			}
		}
	}

	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CMapTool_3DView::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	switch(nIDEvent)
	{
	case 100:
			Render(10.0f);
		break;
	}
	CView::OnTimer(nIDEvent);
}

int CMapTool_3DView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;

	// TODO:  Add your specialized creation code here
	this->SetTimer(100,0,NULL);
	return 0;
}

void CMapTool_3DView::OnDestroy()
{
	CView::OnDestroy();

	// TODO: Add your message handler code here
	KillTimer(100);
}
