// Menu_Attribute.cpp : implementation file
//

#include "stdafx.h"
#include "../MFC/MainFrm.h"
#include "../MFC/MapTool_3D.h"
#include "Menu_Attribute.h"

#include "../DirectX/MapTool_Mgr.h"
#include "../DirectX/Terrain.h"

// CMenu_Attribute dialog

IMPLEMENT_DYNAMIC(CMenu_Attribute, CDialog)

CMenu_Attribute::CMenu_Attribute(CWnd* pParent /*=NULL*/)
	: CDialog(CMenu_Attribute::IDD, pParent)
	, m_strTextureList(_T(""))
	, m_nTextureSplatting(0)
{

}

CMenu_Attribute::~CMenu_Attribute()
{
}

void CMenu_Attribute::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_TEXTURELIST, m_ctrlTextureList);
	DDX_Control(pDX, IDC_LIST_SELECTTEXTURE, m_ctrlSelectTexture);
	DDX_LBString(pDX, IDC_LIST_TEXTURELIST, m_strTextureList);
	DDX_Control(pDX, IDC_BUTTON_TEXTURE_DELETE, m_ctrlButtonDelete);
	DDX_Radio(pDX, IDC_RADIO_TEXTURE_DRAW, m_nTextureSplatting);
}


BEGIN_MESSAGE_MAP(CMenu_Attribute, CDialog)
	ON_LBN_DBLCLK(IDC_LIST_TEXTURELIST, OnLbnDblclkListTexturelist)
	ON_BN_CLICKED(IDC_BUTTON_TEXTURE_DELETE, OnBnClickedButtonTextureDelete)
	ON_LBN_SELCHANGE(IDC_LIST_SELECTTEXTURE, OnLbnSelchangeListSelecttexture)
	ON_LBN_SELCHANGE(IDC_LIST_TEXTURELIST, OnLbnSelchangeListTexturelist)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_RADIO_TEXTURE_DRAW, OnBnClickedRadioTextureDraw)
	ON_BN_CLICKED(IDC_RADIO_TEXTURE_CLEAN, OnBnClickedRadioTextureClean)
END_MESSAGE_MAP()


// CMenu_Attribute message handlers
BOOL CMenu_Attribute::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  ⿡ ߰ ʱȭ ۾ ߰մϴ.
	int i=0;
	CMainFrame *pFr = (CMainFrame *)AfxGetMainWnd();

	POSITION pos	= pFr->m_strTextureList.GetHeadPosition();
	for(i=0; i<pFr->m_strTextureList.GetCount(); ++i)
		m_ctrlTextureList.AddString(pFr->m_strTextureList.GetNext(pos));

	m_ctrlTextureList.SetCurSel(-1);
	m_ctrlTextureList.EnableWindow(FALSE);

	m_ctrlSelectTexture.SetCurSel(-1);

	return TRUE;  // return TRUE unless you set the focus to a control
	// : OCX Ӽ  FALSE ȯؾ մϴ.
}

BOOL CMenu_Attribute::PreTranslateMessage(MSG* pMsg)
{
	// TODO: ⿡ Ưȭ ڵ带 ߰ /Ǵ ⺻ Ŭ ȣմϴ.
	if(pMsg->message == WM_KEYDOWN)
	{
		switch(pMsg->wParam)
		{
			case VK_ESCAPE:
			case VK_RETURN:
			return TRUE;

			default:
			break;
		}
	}

	return CDialog::PreTranslateMessage(pMsg);
}


void CMenu_Attribute::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO: ⿡ ޽ ó ڵ带 ߰մϴ.
	// ׸ ޽ ؼ CDialog::OnPaint()() ȣ ʽÿ.

	if(g_ToolManager.m_pDirect3D)
		g_ToolManager.m_pDirect3D->RenderPreview();
}

void CMenu_Attribute::OnLbnSelchangeListTexturelist()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	// ؽ Ͽ Ҷ  ̹ õ ؽĿ 
	// õ ؽ ġ ؽ  ؽĿ  ̸ ġŲ.
	CString strSrc = L"";
	CString strDest= L"";
	int nSel = m_ctrlTextureList.GetCurSel();
	if(nSel >= 0)
	{
		int i=0;
		for(i=0; i<m_ctrlSelectTexture.GetCount(); ++i)
		{
			m_ctrlTextureList.GetText(nSel, strSrc);
			m_ctrlSelectTexture.GetText(i, strDest);

            if(strSrc == strDest)
				m_ctrlSelectTexture.SetCurSel(i);
		}
	}

	if(g_ToolManager.m_pDirect3D)
	{
		wchar_t* str = (wchar_t*)g_pTerrain->m_strTextureName[m_ctrlTextureList.GetCurSel()].c_str();
		g_ToolManager.m_pDirect3D->LoadPreviewTexture(str);
		Invalidate(FALSE);
	}
}

void CMenu_Attribute::OnLbnDblclkListTexturelist()
{
	int selectTextureNum = m_ctrlSelectTexture.GetCount();
	if(selectTextureNum >= 4)
	{
		AfxMessageBox(L"̻ ؽĸ ߰  ϴ.");
		return; 
	}

	CString strSrc = _T("");
	CString strDest= _T("");
	int nSel = m_ctrlTextureList.GetCurSel();
	if(nSel >= 0)
	{
		for(int i=0; i<m_ctrlSelectTexture.GetCount(); ++i)
		{
			m_ctrlTextureList.GetText(nSel, strSrc);
			m_ctrlSelectTexture.GetText(i, strDest);

            if(strSrc == strDest)
			{
				AfxMessageBox(L" ؽĸ ߰  ϴ.");
				return; 
			}
		}
		UpdateData(TRUE);
		m_nSelectTextureIndex[m_ctrlSelectTexture.GetCount()] = nSel;
		m_ctrlSelectTexture.AddString(m_strTextureList);
		m_ctrlSelectTexture.SetCurSel(m_ctrlSelectTexture.GetCount()-1);

		if(g_pTerrain)
		{
			// ؽĸ   ؽĸ 
			//  ؽİ Ǿ ִ  0x00 .
			g_pTerrain->CreateAlphaTexture(m_ctrlSelectTexture.GetCount()-2);
		}
	}

	Update();
}
void CMenu_Attribute::OnLbnSelchangeListSelecttexture()
{
	// TODO: Add your control notification handler code here
	Update();
}

void CMenu_Attribute::OnBnClickedButtonTextureDelete()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	int nSel = m_ctrlSelectTexture.GetCurSel();
	if(nSel == 0)
	{
		AfxMessageBox(L"⺻ ؽĴ   ϴ.");
		return; 
	}
	if(nSel >= 1) // ⺻ ؽĴ  ϹǷ 1 .
	{
		if(g_pTerrain)
		{
			switch(nSel)
			{
			case 1:
				// ؽİ 1 Ǿ 
				if(m_ctrlSelectTexture.GetCount() == 2)
				{
					// õ  ؽ ȣ -1 .
					// õ  ؽ ̸ .
					//  ؽĸ  ؽķ ̵Ѵ.(SetCurSel)
					m_nSelectTextureIndex[nSel] = -1;
					m_ctrlSelectTexture.DeleteString(nSel);
					m_ctrlSelectTexture.SetCurSel(nSel-1);

					//  ؽİ ̹Ƿ .
					DeleteLastTexture(nSel);
				}
				// ؽİ 2 Ǿ 
				else if(m_ctrlSelectTexture.GetCount() == 3)
				{
					// õ  ؽ ̸ .
					//  ؽĸ ؽİ Ƿ ġ Ų.
					m_ctrlSelectTexture.DeleteString(nSel);
					m_ctrlSelectTexture.SetCurSel(nSel);

					//  ؽİ  ̹Ƿ 缳ϰ .
					DeleteMiddleTexture(nSel);
					DeleteLastTexture(nSel+1);
				}
				// ؽİ 3 Ǿ 
				else if(m_ctrlSelectTexture.GetCount() == 4)
				{
					// õ  ؽ ̸ .
					//  ؽĸ ؽİ Ƿ ġ Ų.
					m_ctrlSelectTexture.DeleteString(nSel);
					m_ctrlSelectTexture.SetCurSel(nSel);

					//  ؽİ 0~3 ؽ  1̹Ƿ 1, 2 缳 3 .
					DeleteMiddleTexture(nSel);
					DeleteMiddleTexture(nSel+1);
					DeleteLastTexture(nSel+2);
				}
				break;

			case 2:
				// ؽİ 2 Ǿ 
				if(m_ctrlSelectTexture.GetCount() == 3)
				{
					m_nSelectTextureIndex[nSel] = -1;
					m_ctrlSelectTexture.DeleteString(nSel);
					m_ctrlSelectTexture.SetCurSel(nSel-1);

					DeleteLastTexture(nSel);
				}
				// ؽİ 3 Ǿ 
				else if(m_ctrlSelectTexture.GetCount() == 4)
				{
					m_ctrlSelectTexture.DeleteString(nSel);
					m_ctrlSelectTexture.SetCurSel(nSel);

					DeleteMiddleTexture(nSel);
					DeleteLastTexture(nSel+1);
				}
				break;

			case 3:
				m_nSelectTextureIndex[nSel] = -1;
				m_ctrlSelectTexture.DeleteString(nSel);
				m_ctrlSelectTexture.SetCurSel(nSel-1);

				DeleteLastTexture(nSel);
				break;
			}
		}
	}

	Update();
}

void CMenu_Attribute::DeleteMiddleTexture(int curSel)
{
	// 1. ؽ 2 1 Ѵ
	g_pTerrain->CreateAlphaTexture(curSel-1);
	g_pTerrain->ChangeAlphaTexture(curSel-1, curSel);

	// 2. ؽ ȣ 3 2 ٲ۴.
	m_nSelectTextureIndex[curSel]		= m_nSelectTextureIndex[curSel+1];
	g_pTerrain->m_nTextureIndex[curSel]	= m_nSelectTextureIndex[curSel+1];
}

void CMenu_Attribute::DeleteLastTexture(int curSel)
{
	// 1. ؽĸ  ٽ Ѵ.
	// 2. ؽ ȣ -1 Ѵ.
	g_pTerrain->CreateAlphaTexture(curSel-1);

	g_pTerrain->m_nTextureIndex[curSel]	= -1;
	m_nSelectTextureIndex[curSel]		= -1;
}

void CMenu_Attribute::Reset()
{
	UpdateData(TRUE);

	//  ߿   ϰų OPENÿ
	// 翡 ִ   ʱȭ Ѵ.
	int i=0;
	for(i=0; i<4; ++i)
	{
		// ؽ   ʱȭ Ѵ.
		m_nSelectTextureIndex[i] = -1;
		g_pTerrain->m_nTextureIndex[i] = -1;
	}

	// õ ؽó ̸  .
	for(i=3; i>=0; --i)
		m_ctrlSelectTexture.DeleteString(i);

	// ؽ    ʱȭ, ؽ   ʱȭ
	m_ctrlTextureList.SetCurSel(-1);
	m_ctrlSelectTexture.SetCurSel(-1);
	g_pTerrain->m_nSelectTextureNum	= -1;
	g_pTerrain->m_nCurTexIndex		= -1;
}

void CMenu_Attribute::GetPreviewHandle()
{
	//  Ʈ ڵ  ´.
	GetDlgItem(IDC_TEXTURELIST_PREVIEW, &m_hWnd_Preview); 
	CStatic *staticSize = (CStatic *)GetDlgItem(IDC_TEXTURELIST_PREVIEW);
	CRect rect;
	staticSize->GetClientRect(rect);
	
	int m_nWidth_Preview  = rect.Width();
	int m_nHeight_Preview = rect.Height();

	g_ToolManager.m_hWnd_Preview	= m_hWnd_Preview;
	g_ToolManager.m_nWidth_Preview	= m_nWidth_Preview;
	g_ToolManager.m_nHeight_Preview	= m_nHeight_Preview;
}

void CMenu_Attribute::OnBnClickedRadioTextureDraw()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	Update();
}

void CMenu_Attribute::OnBnClickedRadioTextureClean()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	Update();
}

void CMenu_Attribute::Update()
{
	UpdateData(TRUE);

	if(g_pTerrain)
	{
		m_ctrlTextureList.EnableWindow(TRUE);

		// ó ʱ⶧ ⺻ ؽĸ ߰Ѵ.
		if(m_ctrlSelectTexture.GetCount() == 0)
		{
			m_nSelectTextureIndex[0] = g_pTerrain->m_nTextureIndex[0];
			CMainFrame *pFr = (CMainFrame *)AfxGetMainWnd();
			POSITION pos	= pFr->m_strTextureList.FindIndex(g_pTerrain->m_nTextureIndex[0]);
			m_ctrlSelectTexture.AddString(pFr->m_strTextureList.GetNext(pos));
		}

		// õ ؽε terrain Ѵ.
		for(int i=0; i<4; ++i)
			g_pTerrain->m_nTextureIndex[i] = m_nSelectTextureIndex[i];

		g_pTerrain->m_nSelectTextureNum	= m_ctrlSelectTexture.GetCount();
		g_pTerrain->m_nCurTexIndex		= m_ctrlSelectTexture.GetCurSel();
		g_pTerrain->m_nTextureSplatting	= m_nTextureSplatting;
	}
}