// Menu_EditMap.cpp : implementation file
//

#include "stdafx.h"
#include "../MFC/MainFrm.h"
#include "../MFC/MapTool_3D.h"
#include "../MFC/MapTool_3DDoc.h"
#include "../MFC/MapTool_3DView.h"

#include "../DirectX/MapTool_Mgr.h"
#include "../DirectX/Terrain.h"

#include "Child_MenuCtrl.h"
#include "Menu_EditMap.h"
// CMenu_EditMap dialog

IMPLEMENT_DYNAMIC(CMenu_EditMap, CDialog)

CMenu_EditMap::CMenu_EditMap(CWnd* pParent /*=NULL*/)
	: CDialog(CMenu_EditMap::IDD, pParent)
	, m_bIsPicking(TRUE)
	, m_nBrushType(-1)
	, m_nInBrush_static(2)
	, m_nOutBrush_static(5)
	, m_bWireFrame(FALSE)
	, m_bBoundaryLine(TRUE)
	, m_bShowTileNumber(TRUE)
	, m_bCoordinateAxis(TRUE)

	, m_nUpDown(0)
	, m_nHeightSize_static(5)
	, m_nFrustumDistance_static(1500)
	, m_bLODCheck(FALSE)
	, m_nLODLevelSize(500)
{

}

CMenu_EditMap::~CMenu_EditMap()
{
}

void CMenu_EditMap::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Radio(pDX, IDC_UPDOWN1, m_nUpDown);
	DDX_Control(pDX, IDC_SLIDER_HIGH, m_ctrlHeightSize);
	DDX_Text(pDX, IDC_STATIC_RATE_HIGH, m_nHeightSize_static);
	DDX_Control(pDX, IDC_SLIDER_FRUSTUME, m_ctrlFrustumDistance);
	DDX_Text(pDX, IDC_STATIC_RATE_FRUSTUM, m_nFrustumDistance_static);
	DDX_Check(pDX, IDC_CHECK_LOD, m_bLODCheck);
	DDX_Control(pDX, IDC_SLIDER_LOD, m_ctrlLODLevelSize);
	DDX_Text(pDX, IDC_STATIC_LOD, m_nLODLevelSize);

	DDX_Check(pDX, IDC_CHECK_BRUSH, m_bIsPicking);
	DDX_Radio(pDX, IDC_TYPE1, m_nBrushType);
	DDX_Control(pDX, IDC_TYPE1, m_ctrlBrushCircle);
	DDX_Control(pDX, IDC_TYPE2, m_ctrlBrushRectangle);
	DDX_Control(pDX, IDC_SLIDER_CLEAR, m_ctrlInBrush);
	DDX_Control(pDX, IDC_SLIDER_SOFT, m_ctrlOutBrush);
	DDX_Text(pDX, IDC_STATIC_CLEAR, m_nInBrush_static);
	DDX_Text(pDX, IDC_STATIC_SOFT, m_nOutBrush_static);
	DDX_Check(pDX, IDC_CHECK_WIREFRAME, m_bWireFrame);
	DDX_Check(pDX, IDC_CHECK_BOUNDARY, m_bBoundaryLine);
	DDX_Check(pDX, IDC_CHECK_SHOWNUM, m_bShowTileNumber);
	DDX_Check(pDX, IDC_CHECK_CORRDINATE, m_bCoordinateAxis);
}


BEGIN_MESSAGE_MAP(CMenu_EditMap, CDialog)
	ON_BN_CLICKED(IDC_UPDOWN1, &CMenu_EditMap::OnBnClickedUpdown1)
	ON_BN_CLICKED(IDC_UPDOWN2, &CMenu_EditMap::OnBnClickedUpdown2)
	ON_BN_CLICKED(IDC_ATT1, &CMenu_EditMap::OnBnClickedAtt1)
	ON_BN_CLICKED(IDC_ATT2, &CMenu_EditMap::OnBnClickedAtt2)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER_HIGH, &CMenu_EditMap::OnNMCustomdrawSliderHigh)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER_FRUSTUME, &CMenu_EditMap::OnNMCustomdrawSliderFrustume)
	ON_BN_CLICKED(IDC_CHECK_LOD, &CMenu_EditMap::OnBnClickedCheckLod)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER_LOD, &CMenu_EditMap::OnNMCustomdrawSliderLod)
	ON_BN_CLICKED(IDC_CHECK_BRUSH, &CMenu_EditMap::OnBnClickedCheckBrush)
	ON_BN_CLICKED(IDC_TYPE1, &CMenu_EditMap::OnBnClickedType1)
	ON_BN_CLICKED(IDC_TYPE2, &CMenu_EditMap::OnBnClickedType2)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER_CLEAR, &CMenu_EditMap::OnNMCustomdrawSliderClear)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER_SOFT, &CMenu_EditMap::OnNMCustomdrawSliderSoft)
	ON_BN_CLICKED(IDC_CHECK_WIREFRAME, &CMenu_EditMap::OnBnClickedCheckWireframe)
	ON_BN_CLICKED(IDC_CHECK_BOUNDARY, &CMenu_EditMap::OnBnClickedCheckBoundary)
	ON_BN_CLICKED(IDC_CHECK_SHOWNUM, &CMenu_EditMap::OnBnClickedCheckShownum)
	ON_BN_CLICKED(IDC_CHECK_CORRDINATE, &CMenu_EditMap::OnBnClickedCheckCorrdinate)
END_MESSAGE_MAP()


BOOL CMenu_EditMap::OnInitDialog()
{
	CDialog::OnInitDialog();


	// TODO:  Add extra initialization here
	((CButton*)GetDlgItem(IDC_UPDOWN1))->SetCheck(0);
	((CButton*)GetDlgItem(IDC_UPDOWN2))->SetCheck(0);
	((CButton*)GetDlgItem(IDC_ATT1))->SetCheck(0);
	((CButton*)GetDlgItem(IDC_ATT2))->SetCheck(0);
	((CButton*)GetDlgItem(IDC_TYPE1))->SetCheck(0);
	((CButton*)GetDlgItem(IDC_TYPE2))->SetCheck(0);

	//   Ʈ 
	m_ctrlHeightSize.SetRange(1, 10);
	m_ctrlHeightSize.SetPos((int)m_nHeightSize_static);
	
	//  
	m_ctrlFrustumDistance.SetRange(1, 40);
	m_ctrlFrustumDistance.SetPos(20);

	// LOD 
	m_ctrlLODLevelSize.EnableWindow(FALSE);
	m_ctrlLODLevelSize.SetRange(5, 20);
	m_ctrlLODLevelSize.SetPos(10);
	m_nLODLevelSize = (int)m_ctrlLODLevelSize.GetPos() * 100;

	// 귯 
	m_nBrushType = -1;
	m_ctrlInBrush.SetRange(1, 20);
	m_ctrlInBrush.SetPos((int)m_nInBrush_static);

	m_ctrlOutBrush.SetRange(1, 20);
	m_ctrlOutBrush.SetPos((int)m_nOutBrush_static);

	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

// CMenu_EditMap message handlers
////////////////////////////////////////////////////////////////
//   
////////////////////////////////////////////////////////////////
void CMenu_EditMap::OnBnClickedUpdown1()
{
	// TODO: Add your control notification handler code here
	m_nUpDown = 0;
	Update();
}

void CMenu_EditMap::OnBnClickedUpdown2()
{
	// TODO: Add your control notification handler code here
	m_nUpDown = 1;
	Update();
}

void CMenu_EditMap::OnBnClickedAtt1()
{
	// TODO: Add your control notification handler code here
	m_nUpDown = 2;
	Update();
}

void CMenu_EditMap::OnBnClickedAtt2()
{
	// TODO: Add your control notification handler code here
	m_nUpDown = 3;
	Update();
}

void CMenu_EditMap::OnNMCustomdrawSliderHigh(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: Add your control notification handler code here
	m_nHeightSize_static = m_ctrlHeightSize.GetPos();
	UpdateData(FALSE);

	Update();

	*pResult = 0;
}

void CMenu_EditMap::OnNMCustomdrawSliderFrustume(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: Add your control notification handler code here
	m_nFrustumDistance_static = m_ctrlFrustumDistance.GetPos() * 100;
	UpdateData(FALSE);

	Update();

	*pResult = 0;
}
////////////////////////////////////////////////////////////////
// LOD
////////////////////////////////////////////////////////////////
void CMenu_EditMap::OnBnClickedCheckLod()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_bLODCheck)
	{
		m_ctrlLODLevelSize.EnableWindow(TRUE);
	}
	else
	{
		m_ctrlLODLevelSize.EnableWindow(FALSE);
	}

	Update();
}

void CMenu_EditMap::OnNMCustomdrawSliderLod(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: Add your control notification handler code here
	m_nLODLevelSize = (int)m_ctrlLODLevelSize.GetPos() * 100;
	UpdateData(FALSE);

	Update();

	*pResult = 0;
}

////////////////////////////////////////////////////////////////
// 귯 
////////////////////////////////////////////////////////////////
void CMenu_EditMap::OnBnClickedCheckBrush()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	if(m_bIsPicking)
	{
		m_ctrlBrushCircle.EnableWindow(TRUE);
		m_ctrlBrushRectangle.EnableWindow(TRUE);
		m_ctrlInBrush.EnableWindow(TRUE);
		m_ctrlOutBrush.EnableWindow(TRUE);
	}
	else
	{
		m_nBrushType = -1;
		m_ctrlBrushCircle.EnableWindow(FALSE);
		m_ctrlBrushCircle.SetCheck(FALSE);
		m_ctrlBrushRectangle.EnableWindow(FALSE);
		m_ctrlBrushRectangle.SetCheck(FALSE);
		m_ctrlInBrush.EnableWindow(FALSE);
		m_ctrlOutBrush.EnableWindow(FALSE);
	}

	Update();
}

void CMenu_EditMap::OnBnClickedType1()
{
	// TODO: Add your control notification handler code here
	if(m_bIsPicking)
		m_nBrushType = 0;
	else
		m_nBrushType = -1;

	Update();
}

void CMenu_EditMap::OnBnClickedType2()
{
	// TODO: Add your control notification handler code here
	if(m_bIsPicking)
		m_nBrushType = 1;
	else
		m_nBrushType = -1;

	Update();
}

void CMenu_EditMap::OnNMCustomdrawSliderClear(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: Add your control notification handler code here
	m_nInBrush_static = m_ctrlInBrush.GetPos();
	UpdateData(FALSE);

	if(m_ctrlOutBrush.GetPos() <= m_ctrlInBrush.GetPos())
	{
		m_ctrlOutBrush.SetPos(m_nInBrush_static);
	}

	Update();
	*pResult = 0;
}

void CMenu_EditMap::OnNMCustomdrawSliderSoft(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: Add your control notification handler code here
	m_nOutBrush_static = m_ctrlOutBrush.GetPos();
	UpdateData(FALSE);

	if(m_ctrlOutBrush.GetPos() <= m_ctrlInBrush.GetPos())
	{
		m_ctrlInBrush.SetPos(m_nOutBrush_static);
	}

	Update();
	*pResult = 0;
}

////////////////////////////////////////////////////////////////
// ɼ 
////////////////////////////////////////////////////////////////
void CMenu_EditMap::OnBnClickedCheckWireframe()
{
	// TODO: Add your control notification handler code here
	Update();
}

void CMenu_EditMap::OnBnClickedCheckBoundary()
{
	// TODO: Add your control notification handler code here
	Update();
}

void CMenu_EditMap::OnBnClickedCheckShownum()
{
	// TODO: Add your control notification handler code here
	Update();
}

void CMenu_EditMap::OnBnClickedCheckCorrdinate()
{
	// TODO: Add your control notification handler code here
	Update();
}

////////////////////////////////////////////////////////////////
// Ʈ Ѱ DX3D ü Ѵ.
////////////////////////////////////////////////////////////////
void CMenu_EditMap::Update()
{
	UpdateData(TRUE);
	CMainFrame *pFrame = (CMainFrame *) AfxGetMainWnd();
	
	if(g_ToolManager.m_pCamera && g_ToolManager.m_pDirect3D)
	{
		//  Ÿ ҷ
		// 1. PROJECTION ִŸ PersPective
		// 2. SetTransform  Ѵ.
		// 3. Ȱ ġ Ѵ.(:ִŸ-100, :ִŸ-10)
		
		float dist = (float)m_nFrustumDistance_static*1.0f;
		g_ToolManager.m_pCamera->SetProjParams(D3DX_PI/4, (float)pFrame->m_pWorkView->m_nWidth/(float)pFrame->m_pWorkView->m_nHeight, 1.0f, dist);
		g_ToolManager.m_pDirect3D->GetDevice()->SetTransform(D3DTS_PROJECTION, &g_ToolManager.m_pCamera->GetProjMatrix());
	//	g_ToolManager.m_pDirect3D->SetUpFog(dist-100.0f, dist-10.0f);
	}
    
	if(g_pTerrain)
	{
		//  ø//ϰ/    Ѵ.
		g_pTerrain->m_nUpDownMode = m_nUpDown;
		g_pTerrain->m_nHeightRate = m_nHeightSize_static;

		g_pTerrain->m_bApplyLOD		= m_bLODCheck;
		g_pTerrain->m_nLODLevelSize = m_nLODLevelSize;
	}

	// Ʈ (, ؽ, Ʈ)
	g_ToolManager.m_nEditMode	= pFrame->m_pChd_Menu->m_MenuTab.GetCurSel();

	// 귯
	g_ToolManager.m_bIsPicking	= m_bIsPicking;


	//  ɼ
	g_ToolManager.m_bCoordinateAxis = m_bCoordinateAxis;


	if(g_pTerrain)
	{
		// 귯
		g_pTerrain->m_nBrushType	= m_nBrushType;
		g_pTerrain->m_fBrushInSize	= (float)m_nInBrush_static;
		g_pTerrain->m_fBrushOutSize	= (float)m_nOutBrush_static;

		//  ɼ
		g_pTerrain->m_bWireFrame	= m_bWireFrame;
		g_pTerrain->m_bBoundaryLine	= m_bBoundaryLine;
//		g_pTerrain->m_bFog			= FALSE; //m_bFog;
		g_pTerrain->m_bLight		= TRUE;
	}

	pFrame->m_pChd_Menu->m_Menu_Att->Update();
	pFrame->m_pChd_Menu->m_Menu_Player->Update();
}

BOOL CMenu_EditMap::PreTranslateMessage(MSG* pMsg)
{
	// TODO: Add your specialized code here and/or call the base class
	if(pMsg->message == WM_KEYDOWN)
	{
		switch(pMsg->wParam)
		{
			case VK_ESCAPE:
			case VK_RETURN:
			return TRUE;

			default:
			break;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}
