// Menu_Particle.cpp : implementation file
//

#include "stdafx.h"
#include "../mfc/MapTool_3D.h"
#include "Menu_Particle.h"
#include "../DirectX/Shader_Fog.h"
#include "../DirectX/pSystem.h"


// CMenu_Particle dialog

IMPLEMENT_DYNAMIC(CMenu_Particle, CDialog)

CMenu_Particle::CMenu_Particle(CWnd* pParent /*=NULL*/)
	: CDialog(CMenu_Particle::IDD, pParent)
	, m_Fog_Exp2(0.1)
	, m_Fog_Start(0)
	, m_Fog_end(1000)
	, m_Fog_Color_R(100)
	, m_Fog_Color_G(100)
	, m_Fog_Color_B(100)
	, m_Fog_Color_A(0)
	, m_iSnow_Count(1000)
	, m_fSnow_Min_x(0)
	, m_fSnow_Min_y(10)
	, m_fSnow_Min_z(-5000)
	, m_fSnow_Max_x(5000)
	, m_fSnow_Max_y(500)
	, m_fSnow_Max_z(0)
	, m_fSnow_Size(7)
{
	g_Option._Fog._using = true;
	g_Option._Fog.color = MAKELONG(MAKEWORD(m_Fog_Color_B,m_Fog_Color_G),MAKEWORD(m_Fog_Color_R,m_Fog_Color_A));
	g_Option._Fog.exp2 = m_Fog_Exp2;
	g_Option._Fog.fog_start = m_Fog_Start;
	g_Option._Fog.fog_end = m_Fog_end;
	
	g_Option._Snow._using = true;
	g_Option._Snow.number = m_iSnow_Count;
	g_Option._Snow.size = m_fSnow_Size;

	g_Option._Snow.box_min_pt.x = m_fSnow_Min_x;
	g_Option._Snow.box_min_pt.y = m_fSnow_Min_y;
	g_Option._Snow.box_min_pt.z = m_fSnow_Min_z;

	g_Option._Snow.box_max_pt.x = m_fSnow_Max_x;
	g_Option._Snow.box_max_pt.y = m_fSnow_Max_y;
	g_Option._Snow.box_max_pt.z = m_fSnow_Max_z;
}

CMenu_Particle::~CMenu_Particle()
{
}

void CMenu_Particle::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PAR_C_FOG, m_Fog_Use);
	DDX_Text(pDX, IDC_FOG_EXP2, m_Fog_Exp2);
	DDV_MinMaxFloat(pDX, m_Fog_Exp2, 0, 1);

	DDX_Text(pDX, IDC_FOG_START, m_Fog_Start);
	DDV_MinMaxFloat(pDX, m_Fog_Start, 0.0, 1024.0);
	DDX_Text(pDX, IDC_FOG_END, m_Fog_end);
	DDV_MinMaxFloat(pDX, m_Fog_end, 0.0, 8024);

	DDX_Text(pDX, IDC_PAR_FORCOLOR_R, m_Fog_Color_R);
	DDV_MinMaxInt(pDX, m_Fog_Color_R, 0, 255);
	DDX_Text(pDX, IDC_PAR_FORCOLOR_G, m_Fog_Color_G);
	DDV_MinMaxInt(pDX, m_Fog_Color_G, 0, 255);
	DDX_Text(pDX, IDC_PAR_FORCOLOR_B, m_Fog_Color_B);
	DDV_MinMaxInt(pDX, m_Fog_Color_B, 0, 255);
	DDX_Text(pDX, IDC_PAR_FORCOLOR_A, m_Fog_Color_A);
	DDV_MinMaxInt(pDX, m_Fog_Color_A, 0, 255);

	DDX_Text(pDX, IDC_E_SNOW_NUM, m_iSnow_Count);
	DDV_MinMaxUInt(pDX, m_iSnow_Count, 0, 5000);
	DDX_Text(pDX, IDC_E_SNOW_MIN_X, m_fSnow_Min_x);
	DDX_Text(pDX, IDC_E_SNOW_MIN_Y, m_fSnow_Min_y);
	DDX_Text(pDX, IDC_E_SNOW_MIN_Z, m_fSnow_Min_z);
	DDX_Text(pDX, IDC_E_SNOW_MAX_X, m_fSnow_Max_x);
	DDX_Text(pDX, IDC_E_SNOW_MAX_Y, m_fSnow_Max_y);
	DDX_Text(pDX, IDC_E_SNOW_MAX_Z, m_fSnow_Max_z);
	DDX_Text(pDX, IDC_E_SNOW_SIZE, m_fSnow_Size);
	DDV_MinMaxFloat(pDX, m_fSnow_Size, 0, 500);
}


BEGIN_MESSAGE_MAP(CMenu_Particle, CDialog)
	ON_BN_CLICKED(IDC_PAR_C_FOG, &CMenu_Particle::OnBnClickedParCFog)
	ON_BN_CLICKED(IDC_PAR_C_SNOW, &CMenu_Particle::OnBnClickedParCSnow)
END_MESSAGE_MAP()


// CMenu_Particle message handlers


BOOL CMenu_Particle::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  Add extra initialization here
	((CButton*)GetDlgItem(IDC_PAR_C_SNOW))->SetCheck(true);
	g_Option._Snow._using = true;

	((CButton*)GetDlgItem(IDC_PAR_C_FOG))->SetCheck(true);
	g_Option._Fog._using = true;

	((CButton*)GetDlgItem(IDC_PAR_FOG1))->SetCheck(true);
	g_Option._Fog.style = Option_Shader_Fog::Layer;

	SetControlItem(Particle::All, true);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CMenu_Particle::PreTranslateMessage(MSG* pMsg)
{
	// TODO: Add your specialized code here and/or call the base class
	if(pMsg->message == WM_KEYDOWN)
	{
		if(pMsg->wParam == VK_ESCAPE) return TRUE;
		if(pMsg->wParam == VK_RETURN) return TRUE;
		this->UpdateData();
	}
	if(pMsg->message == WM_LBUTTONDOWN)
		this->UpdateData();

	if(((CButton*)GetDlgItem(IDC_PAR_FOG1))->GetCheck())
		g_Option._Fog.style = Option_Shader_Fog::Exp2;

	if(((CButton*)GetDlgItem(IDC_PAR_FOG2))->GetCheck())
		g_Option._Fog.style = Option_Shader_Fog::Linear;

	if(((CButton*)GetDlgItem(IDC_PAR_FOG3))->GetCheck())
		g_Option._Fog.style = Option_Shader_Fog::Layer;

	if(((CButton*)GetDlgItem(IDC_PAR_C_FOG))->GetCheck())
		g_Option._Fog._using = true;
	else
		g_Option._Fog._using = false;

	g_Option._Fog.color = MAKELONG(MAKEWORD(m_Fog_Color_B,m_Fog_Color_G),MAKEWORD(m_Fog_Color_R,m_Fog_Color_A));
	g_Option._Fog.exp2 = m_Fog_Exp2;
	g_Option._Fog.fog_start = m_Fog_Start;
	g_Option._Fog.fog_end = m_Fog_end;

	g_Option._Snow.number = m_iSnow_Count;
	g_Option._Snow.size = m_fSnow_Size;

	g_Option._Snow.box_min_pt.x = m_fSnow_Min_x;
	g_Option._Snow.box_min_pt.y = m_fSnow_Min_y;
	g_Option._Snow.box_min_pt.z = m_fSnow_Min_z;

	g_Option._Snow.box_max_pt.x = m_fSnow_Max_x;
	g_Option._Snow.box_max_pt.y = m_fSnow_Max_y;
	g_Option._Snow.box_max_pt.z = m_fSnow_Max_z;

	return CDialog::PreTranslateMessage(pMsg);
}

void CMenu_Particle::SetControlItem(Particle flag, bool Enable)
{
	if(flag == Particle::Fog || flag == Particle::All)
	{
		((CButton*)GetDlgItem(IDC_PAR_FOG1))->EnableWindow(Enable);
		((CButton*)GetDlgItem(IDC_PAR_FOG2))->EnableWindow(Enable);
		((CButton*)GetDlgItem(IDC_PAR_FOG3))->EnableWindow(Enable);
		((CButton*)GetDlgItem(IDC_FOG_EXP2))->EnableWindow(Enable);
		((CButton*)GetDlgItem(IDC_FOG_START))->EnableWindow(Enable);
		((CButton*)GetDlgItem(IDC_FOG_END))->EnableWindow(Enable);
		((CButton*)GetDlgItem(IDC_PAR_FORCOLOR_R))->EnableWindow(Enable);
		((CButton*)GetDlgItem(IDC_PAR_FORCOLOR_G))->EnableWindow(Enable);
		((CButton*)GetDlgItem(IDC_PAR_FORCOLOR_B))->EnableWindow(Enable);
		((CButton*)GetDlgItem(IDC_PAR_FORCOLOR_A))->EnableWindow(Enable);
	}

	if(flag == Particle::Snow || flag == Particle::All)
	{
		((CButton*)GetDlgItem(IDC_E_SNOW_NUM))->EnableWindow(Enable);

		((CButton*)GetDlgItem(IDC_E_SNOW_MIN_X))->EnableWindow(Enable);
		((CButton*)GetDlgItem(IDC_E_SNOW_MIN_Y))->EnableWindow(Enable);
		((CButton*)GetDlgItem(IDC_E_SNOW_MIN_Z))->EnableWindow(Enable);
		
		((CButton*)GetDlgItem(IDC_E_SNOW_MAX_X))->EnableWindow(Enable);
		((CButton*)GetDlgItem(IDC_E_SNOW_MAX_Y))->EnableWindow(Enable);
		((CButton*)GetDlgItem(IDC_E_SNOW_MAX_Z))->EnableWindow(Enable);

		((CButton*)GetDlgItem(IDC_E_SNOW_SIZE))->EnableWindow(Enable);
		((CButton*)GetDlgItem(IDC_B_SNOW_FILE))->EnableWindow(Enable);
	}
}

void CMenu_Particle::OnBnClickedParCFog()
{
	// TODO: Add your control notification handler code here
	// üũ ư   ó
	if(((CButton*)GetDlgItem(IDC_PAR_C_FOG))->GetCheck())
	{
		g_Option._Fog._using = true;
		SetControlItem(Particle::Fog, true);
	}
	else
	{
		g_Option._Fog._using = false;
		SetControlItem(Particle::Fog, false);
	}
}

void CMenu_Particle::OnBnClickedParCSnow()
{
	// TODO: Add your control notification handler code here
	// üũ ư   ó
	if(((CButton*)GetDlgItem(IDC_PAR_C_SNOW))->GetCheck())
	{
		g_Option._Snow._using = true;
		SetControlItem(Particle::Snow, true);
	}
	else
	{
		g_Option._Snow._using = false;
		SetControlItem(Particle::Snow, false);
	}
}

void CMenu_Particle::Update()
{

}